    --
    -- Copyright (c) Microsoft Corporation. All rights reserved.
    --
declare @x int
select @x=count(*) from sys.messages where message_id = 50100;
if (@x=1) exec sp_dropmessage 50100 ,us_english 
exec sp_addmessage @msgnum=50100, @severity=16, @msgtext=N'parameter cannot be null: <%s>', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 50200;
if (@x=1) exec sp_dropmessage 50200 ,us_english
exec sp_addmessage @msgnum=50200, @severity=16, @msgtext=N'Principals not provisioned: <%s>', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 50201;
if (@x=1) exec sp_dropmessage 50201 ,us_english
exec sp_addmessage @msgnum=50201, @severity=16, @msgtext=N'Must provide a display name and/or a company name', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 50202;
if (@x=1) exec sp_dropmessage 50202 ,us_english
exec sp_addmessage @msgnum=50202, @severity=16, @msgtext=N'Principals are disabled: <%s>', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 50291;
if (@x=1) exec sp_dropmessage 50291 ,us_english
exec sp_addmessage @msgnum=50291, @severity=16, @msgtext=N'Failed to save preference. Existing sequence id is <%d>, and the provided sequence id <%d> did not match.', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 50300;
if (@x=1) exec sp_dropmessage 50300 ,us_english
exec sp_addmessage @msgnum=50300, @severity=16, @msgtext=N'Parent must be a category.  Invalid parent: <%s (%s)>', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 50301;
if (@x=1) exec sp_dropmessage 50301 ,us_english
exec sp_addmessage @msgnum=50301, @severity=16, @msgtext=N'Parent cannot be a descendent.  Invalid parent: <%s (%s)>.', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 50302;
if (@x=1) exec sp_dropmessage 50302 ,us_english
exec sp_addmessage @msgnum=50302, @severity=16, @msgtext=N'Parent of a category must be the root.  Invalid parent: <%s (%s)>', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 50303;
if (@x=1) exec sp_dropmessage 50303 ,us_english
exec sp_addmessage @msgnum=50303, @severity=16, @msgtext=N'Parent of a channel cannot be root.  Invalid parent: <%s (%s)>', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 50320;
if (@x=1) exec sp_dropmessage 50320 ,us_english
exec sp_addmessage @msgnum=50320, @severity=16, @msgtext=N'These principals are already defined on the node: <%s>', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 50321;
if (@x=1) exec sp_dropmessage 50321 ,us_english
exec sp_addmessage @msgnum=50321, @severity=16, @msgtext=N'These principals are not in scope: <%s>', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 50322;
if (@x=1) exec sp_dropmessage 50322 ,us_english
exec sp_addmessage @msgnum=50322, @severity=16, @msgtext=N'Limit exceeded. Allowed: <%d>, Existing: <%d>, New: <%d>', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 50324;
if (@x=1) exec sp_dropmessage 50324 ,us_english
exec sp_addmessage @msgnum=50324, @severity=16, @msgtext=N'Voiced principals are not defined in the members list of this node: <%s>', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 50340;
if (@x=1) exec sp_dropmessage 50340 ,us_english
exec sp_addmessage @msgnum=50340, @severity=16, @msgtext=N'Siop name is already in use: <%s>', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 50341;
if (@x=1) exec sp_dropmessage 50341 ,us_english
exec sp_addmessage @msgnum=50341, @severity=16, @msgtext=N'Siop id is already in use: <%s>', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 51100;
if (@x=1) exec sp_dropmessage 51100 ,us_english
exec sp_addmessage @msgnum=51100, @severity=16, @msgtext=N'%s already exists and insertOnly is true: <%s>', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 51101;
if (@x=1) exec sp_dropmessage 51101 ,us_english
exec sp_addmessage @msgnum=51101, @severity=16, @msgtext=N'AddedBy user does not exist: <%s>', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 51102;
if (@x=1) exec sp_dropmessage 51102 ,us_english
exec sp_addmessage @msgnum=51102, @severity=16, @msgtext=N'UpdatedBy user does not exist: <%s>', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 51103;
if (@x=1) exec sp_dropmessage 51103 ,us_english
exec sp_addmessage @msgnum=51103, @severity=16, @msgtext=N'%s already exist and insertOnly is true for: <%s>', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 51104;
if (@x=1) exec sp_dropmessage 51104 ,us_english
exec sp_addmessage @msgnum=51104, @severity=16, @msgtext=N'Node does not exist: <%s>', @lang='us_english'
select @x=count(*) from sys.messages where message_id = 51107;
if (@x=1) exec sp_dropmessage 51107 ,us_english
exec sp_addmessage @msgnum=51107, @severity=16, @msgtext=N'Schema <%s> is not supported.  Expected schema <%s>', @lang='us_english'
go
create function dbo.fnTicksToDate (@Ticks bigint)
returns datetime
with schemabinding
 begin
    declare @Days bigint
    declare @DaysBefore1753 bigint
    declare @TimeTicks bigint
    declare @Seconds bigint
    declare @Ms bigint
    set @Days = @Ticks / convert(bigint, 864000000000)
    set @DaysBefore1753 = convert(bigint, 639905)
    set @TimeTicks = @Ticks % convert(bigint, 864000000000)
    set @Seconds = @TimeTicks / convert(bigint, 10000000)
    set @Ms = (@TimeTicks % convert(bigint, 10000000)) / convert(bigint, 10000)
    return dateadd(ms, @Ms, dateadd(s, @Seconds, dateadd(d, @Days - @DaysBefore1753, convert(datetime, '1/1/1753'))))
 end 
go
create function [dbo].fnDateToTicks (@parm_date datetime)
returns bigint
with schemabinding
 begin
    declare
      @Days bigint
     ,@Hours bigint
     ,@Mins bigint
     ,@Secs bigint
     ,@Ms bigint
     ,@Ticks bigint
    set @Days = cast(datediff(day, '1/1/1753', @parm_date) as bigint)
    set @Hours = datepart(hour, @parm_date) + (@Days * 24)
    set @Mins = datepart(minute, @parm_date) + (@Hours * 60)
    set @Secs = datepart(second, @parm_date) + (@Mins * 60)
    set @Ms = datepart(ms, @parm_date) + (@Secs * 1000)
    set @Ticks = (@Ms * 10000) + 552877920000000000
    return (@Ticks)
 end
go
create function [dbo].fnDateToMilliseconds (@parm_date datetime)
returns bigint
with schemabinding
 begin
    declare @Milliseconds bigint
    set @Milliseconds = cast(datediff(day, cast('01/01/1970' as datetime), @parm_date) as bigint) * (3600 * 24 * 1000)
    return @Milliseconds
 end
go
create function [dbo].fnMillisecondsToDate (@parm_ms bigint)
returns datetime
with schemabinding
 begin
    declare @derivedDate datetime
    set @derivedDate = cast('01/01/1970' as datetime) + @parm_ms / (3600 * 24 * 1000) ;
    return @derivedDate
 end
go
create function [dbo].fnParseDelimitedStringForString (@xml xml)
returns @table_var table (entry nvarchar(400))
with schemabinding
 begin
    insert
      @table_var
    select distinct
			id.value('@id', 'nvarchar(400)') 
		from 
			@xml.nodes('ROOT/r') item (id)
    return
 end
go
create function [dbo].fnParseDelimitedStringForInt (@xml xml)
returns @table_var table (entry int)
with schemabinding
 begin
    insert
      @table_var
    select distinct
			id.value('@id', 'int') 
		from 
			@xml.nodes('ROOT/r') item (id)
    return
 end
go
create function [dbo].fnParseDelimitedStringForIntWithIndex (@xml xml)
returns @table_var table
  (
   [index] int identity
  ,[entry] int
  )
with schemabinding
 begin
    insert
      @table_var
    select distinct
			id.value('@id', 'int') 
		from 
			@xml.nodes('ROOT/r') item (id)
    return
 end
go
create function [dbo].fnParseXmlStringForKeyValuePairs (@xml xml)
returns @table_var table
  (
   [key] nvarchar(300)
  ,[value] int
  )
with schemabinding
 begin
    insert
      @table_var
    select
		id.value('@k', 'nvarchar(300)')
		,id.value('@v', 'int')
		from 
			@xml.nodes('ROOT/r') item (id)
    return
 end
go
create function [dbo].fnParseXmlForStringsEscapedForUseWithLike (@xml xml)
returns @table_var table (entry nvarchar(512))
with schemabinding
 begin
    insert
      @table_var
    select distinct
       replace(
       replace(
       replace(
       replace(
       replace(
       replace(
       replace(id.value('@id', 'nvarchar(512)')
       , '!', '!!' )
       , '%', '!%' )
       , '$', '!$' )
       , '_', '!_' )
       , '[', '![' )
       , ']', '!]' )
       , '^', '!^' )
		from 
			@xml.nodes('ROOT/r') item (id)
    return
 end
go
create procedure [dbo].procGetDBTime
as
 begin 
  select
    getutcdate()
 end
go
create procedure [dbo].[RethrowError] 
	@state int = null
as 
  if error_number() is null 
    return -- return if there is no error information to retrieve.
  declare
    @message nvarchar(4000)
   ,@number int
   ,@severity int
   ,@lineNumber int
   ,@procName nvarchar(200)
  select
    @severity = error_severity()
   ,@state = isnull(@state, error_state())
   ,@lineNumber = error_line()
   ,@procName = isnull(error_procedure(), '-')
   ,@number = error_number()
  if(@number = 50000)
		set @message = error_message()
	else
		set @message = N'[%d][%d][%s][%d] ' + error_message()
  raiserror (@message, @severity, @state, 
		@number, -- parameter: original error number.
    @severity, -- parameter: original error severity.
    @procName, -- parameter: original error procedure name.
    @lineNumber-- parameter: original error line number.
    )
go
create procedure [dbo].[procGetConfig]
  @label nvarchar(255)
as 
  select
    [configLabel]
   ,[configContent]
  from
    tblConfig
  where
    configLabel = @label
go
create procedure [dbo].[procGetPoolId]
as 
  select
    [configPoolID]
  from
    [tblConfig]
go
create procedure [dbo].procGetAdminLock_p
as 
  declare @sysRevision bigint
  if exists ( select top 1
                sysRevision
              from
                tblSystemRevision ) 
    set @sysRevision = (
                        select top 1 sysRevision from tblSystemRevision
                       )
  else 
    set @sysRevision = 0
		
  select
    @sysRevision as sysRevision
   ,*
  from
    tblAdminLock
GO
create procedure [dbo].procGetSystemRevision
as 
  if exists ( select top 1
                sysRevision
              from
                tblSystemRevision ) 
    select top 1
      sysRevision
    from
      tblSystemRevision
  else 
    select
      cast(0 as bigint) as sysRevision
		
GO
create procedure [dbo].procUpdateSystemRevision
  @newSystemRevision bigint
as 
  if exists ( select top 1
                sysRevision
              from
                tblSystemRevision ) 
    update
      tblSystemRevision
    set
      sysRevision = @newSystemRevision
  else 
    insert into
      tblSystemRevision (sysRevision)
    values
      (@newSystemRevision)
GO
create procedure [dbo].procAcquireAdminLock
  @serverID int
 ,@actorID int
 ,@duration int
as 
  declare
    @result int
   ,@now datetime
   ,@expiresTime datetime
  begin transaction
  exec @result = sp_getapplock @Resource = 'AdminLock',
    @LockMode = 'Exclusive'
  if @result < 0 
    begin
      rollback transaction
    end
  else 
    begin
      set @now = getutcdate()
      if exists ( select
                    *
                  from
                    tblAdminLock
                  where
                    lockExpiresTime >= @now ) 
        set @result = -10 -- someone else has the lock right now
      else 
        begin
          set @expiresTime = dateadd(ms, @duration, @now)
          delete from
            tblAdminLock -- remove any expired locks
          insert into
            tblAdminLock
            (
             lockExpiresTime
            ,lockServerID
            ,lockActorID
            )
          values
            (
             @expiresTime
            ,@serverID
            ,@actorID
            )
        end
      exec sp_releaseapplock @Resource = 'AdminLock'
      commit transaction
    end ;
  select
    @result as result
  exec procGetAdminLock_p
GO
create procedure [dbo].procExtendAdminLock
  @serverID int
 ,@actorID int
 ,@duration int
as 
  declare
    @result int
   ,@now datetime
   ,@newExpiresTime datetime
  begin transaction
  exec @result = sp_getapplock @Resource = 'AdminLock',
    @LockMode = 'Exclusive'
  if @result < 0 
    begin
      rollback transaction
    end
  else 
    begin
      set @now = getutcdate()
      if exists ( select
                    *
                  from
                    tblAdminLock
                  where
                    lockExpiresTime >= @now
                    and lockServerID = @serverID
                    and lockActorID = @actorID ) 
        begin
          select
            @newExpiresTime = dateadd(ms, @duration, lockExpiresTime)
          from
            tblAdminLock
          update
            tblAdminLock
          set
            lockExpiresTime = @newExpiresTime
          where
            lockServerID = @serverID
            and lockActorID = @actorID
        end
      else 
        set @result = -11 -- we are not the owner of the admin lock or it has already expired
      exec sp_releaseapplock @Resource = 'AdminLock'
      commit transaction
    end ;
  select
    @result as result
  exec procGetAdminLock_p
GO
create procedure [dbo].procReleaseAdminLock
  @serverID int
 ,@actorID int
 ,@newSystemRevision bigint
as 
  declare @result int
  begin transaction
  exec @result = sp_getapplock @Resource = 'AdminLock',
    @LockMode = 'Exclusive'
  if @result < 0 
    begin
      rollback transaction
    end
  else 
    begin
      if exists ( select
                    *
                  from
                    tblAdminLock
                  where
                    lockServerID = @serverID
                    and lockActorID = @actorID ) 
        begin
          exec procUpdateSystemRevision @newSystemRevision
          delete from
            tblAdminLock
        end
      else 
        set @result = -11 -- we are not the owner of the admin lock or it has already expired
      exec sp_releaseapplock @Resource = 'AdminLock'
      commit transaction
    end ;
  select
    @result as result
  exec procGetAdminLock_p
GO
create procedure [dbo].procExtendKeepAlive @serverID int
as 
  update
    tblServerIdentity
  set
    serverLastPingTime = getutcdate()
  where
    serverID = @serverID
go
create procedure [dbo].[procUpdateServerIdentity]
  @parmServerID int
 ,@parmServerAddress nvarchar(256)
as 
  set nocount on
  delete from [tblActivePeers] where [aplServerID] = @parmServerID
  delete from [tblActivePeers] where [aplPeerID] = @parmServerID
  delete from [tblServerIdentity] 
    where 
     [serverID] = @parmServerID
  insert into 
     tblServerIdentity(serverID, serverAddress)
    values
     (@parmServerID, @parmServerAddress)   
GO
create procedure [dbo].procUpdateActivePeers @serverID int, @xml xml
as 
  set transaction isolation level read committed
  begin transaction
  begin try
  delete from
    tblActivePeers
  where
    aplServerID = @serverID
  insert into
    tblActivePeers
    select
      @serverID as aplServerID
     ,ids.entry as aplPeerID
    from
      fnParseDelimitedStringForInt(@xml) ids
  commit transaction
  end try
  begin catch
    rollback transaction
    exec RethrowError
    return -1
  end catch
  exec procExtendKeepAlive @serverID
GO
create procedure [dbo].procGetActivePeerCluster
  @serverPingInterval int -- in milliseconds
as -- Purges the active peers list of any servers that haven't pinged within the specified ping interval
  declare
    @utcNow datetime
   ,@allowedPingTime datetime
  set @utcNow = getutcdate()
  set @allowedPingTime = dateadd(ms, @serverPingInterval * -1, @utcNow)
  delete from
    tblActivePeers
  where
    aplServerID in (select
                      serverID
                    from
                      tblServerIdentity
                    where
                      serverLastPingTime < @allowedPingTime)
    or aplPeerID in (select
                      serverID
                     from
                      tblServerIdentity
                     where
                      serverLastPingTime < @allowedPingTime)
    select
        aplServerID serverA
      , aplPeerID serverB
    from tblActivePeers
	order by aplServerID
    select
      serverID
    from
      tblServerIdentity
    where
      serverLastPingTime > @allowedPingTime
GO
create function [dbo].[fnBitmaskContains](@bitmask int, @match int) 
                        returns bit
                        with schemabinding
                        begin
                              declare @result bit
                              if ((@bitmask & @match) = @match)
                                    set @result = 1
                              else
                                    set @result = 0 
                              return @result
                        end
go
create procedure [dbo].[procGetAllDomainGuids]
as 
  set transaction isolation level read committed
  select
    p.[prinGuid]
  from
    [tblPrincipal] p
    inner join tblPrincipalType pt on p.[prinTypeID] = pt.[ptypeID]
                                      and pt.ptypeDesc = 'Active Directory DC'
go
create procedure [dbo].[procGetPrincipalAffiliationKeys] @prinID int
as 
  set transaction isolation level read committed
  select
    af.[prinID]
   ,af.[prinName]
   ,af.[prinGuid]
   ,af.[prinUri]
  from
    tblPrincipalAffiliations a
    inner join tblPrincipal af on af.prinID = a.affiliationID
  where
    a.principalID = @prinID
    and af.prinDisabled = 0
    and a.[index] <> -1
go
create procedure [dbo].[procGetUserIdsByAffiliation] @groupId nvarchar(80)
as 
  set transaction isolation level read committed
  select
    p.[prinID] as [id]
  from
    [tblPrincipal] p
    inner join [tblPrincipalType] t on p.[prinTypeID] = t.[ptypeID]
    inner join [tblPrincipalAffiliations] gu on p.[prinID] = gu.[principalID]
    inner join [tblPrincipal] g on gu.[affiliationID] = g.[prinID]
  where
    g.[prinID] = @groupId
    and t.[ptypeIsUser] = 1
    and t.[ptypeIsSystemUser] = 0
    and p.prinDisabled = 0
go
create procedure [dbo].[procInsertPrincipal_p]
  (
   @parmPrinName nvarchar(256)
  ,@parmPrinDispName nvarchar(256)
  ,@parmPrinCompany nvarchar(256)
  ,@parmPrinGuid uniqueidentifier
  ,@parmPrinUri nvarchar(256)
  ,@parmPrinEmail nvarchar(256)
  ,@parmPrinADPath nvarchar(384)
  ,@parmPrinADUserName nvarchar(256)
  ,@parmPrinDisabled smallint
  ,@parmPrinTypeID smallint
  ,@parmPrinAddedBy int
  ,@parmPrinAddedOn bigint
  ,@parmPrinUpdatedBy int
  ,@parmPrinUpdatedOn bigint
  ,@parmPrinPoolID int
  ,@parmPrinPolicyID int
  ,@parmPrinID int = 0 output
  )
as 
  set nocount on
  declare
    @Tc int
   ,@Sp varchar(10)
  select
    @Tc = @@trancount
   ,@Sp = @@procid
  if (@Tc = 0) 
    begin
      set transaction isolation level read committed
      begin transaction @Sp
    end
  else 
    begin
      save transaction @Sp
    end
  begin try
    insert into
      [tblPrincipal]
      (
       [prinName]
      ,[prinDisplayName]
      ,[prinCompanyName]
      ,[prinGuid]
      ,[prinUri]
      ,[prinEmail]
      ,[prinADPath]
      ,[prinADUserPrincipalName]
      ,[prinDisabled]
      ,[prinTypeID]
      ,[prinAddedBy]
      ,[prinAddedOn]
      ,[prinUpdatedBy]
      ,[prinUpdatedOn]
      ,[prinPoolID]
      ,[prinPolicyID]
      )
    values
      (
       @parmPrinName
      ,@parmPrinDispName
      ,@parmPrinCompany
      ,@parmPrinGuid
      ,@parmPrinUri
      ,@parmPrinEmail
      ,@parmPrinADPath
      ,@parmPrinADUserName
      ,@parmPrinDisabled
      ,@parmPrinTypeID
      ,@parmPrinAddedBy
      ,@parmPrinAddedOn
      ,@parmPrinUpdatedBy
      ,@parmPrinUpdatedOn
      ,@parmPrinPoolID
      ,@parmPrinPolicyID
      )
    set @parmPrinID = cast(scope_identity() as int)
	--inserts the self-affiliation, necessary when searching for principals defining scope & roles
    insert into
      [tblPrincipalAffiliations]
      (
       [principalID]
      ,[affiliationID]
      ,[index]
      ,[updatedBy]        
      )
    values
      (
       @parmPrinID
      ,@parmPrinID
      ,-1
      ,@parmPrinAddedBy        
      )
    if (@Tc = 0) 
      commit transaction @Sp
  end try
  begin catch
    exec RethrowError
    if (xact_state() <> 0) 
      begin
        rollback transaction @Sp
        return -1
      end
  end catch
go
create procedure [dbo].[procInsertPrincipal]
  (
   @parmPrinName nvarchar(256)
  ,@parmPrinDispName nvarchar(256)
  ,@parmPrinCompany nvarchar(256)
  ,@parmPrinGuid nvarchar(36)
  ,@parmPrinUri nvarchar(256)
  ,@parmPrinEmail nvarchar(256)
  ,@parmPrinADPath nvarchar(384)
  ,@parmPrinADUserName nvarchar(256)
  ,@parmPrinDisabled smallint
  ,@parmPrinTypeID smallint
  ,@parmPrinAddedBy int
  ,@parmPrinAddedOn bigint
  ,@parmPrinPoolID int
  ,@parmPrinPolicyID int
  ,@parmPrinID int = 0 output
  )
as 
  declare @prinGuid uniqueidentifier
  set @prinGuid = convert(uniqueidentifier, @parmPrinGuid)
  exec [procInsertPrincipal_p] @parmPrinName = @parmPrinName, -- nvarchar(256)
    @parmPrinDispName = @parmPrinDispName, -- nvarchar(256)
    @parmPrinCompany = @parmPrinCompany, -- nvarchar(256)
    @parmPrinGuid = @prinGuid, -- nvarchar(80)
    @parmPrinUri = @parmPrinUri, -- nvarchar(256)
    @parmPrinEmail = @parmPrinEmail, -- nvarchar(256)
    @parmPrinADPath = @parmPrinADPath, -- nvarchar(384)
    @parmPrinADUserName = @parmPrinADUserName, -- nvarchar(256)
    @parmPrinDisabled = @parmPrinDisabled, -- smallint
    @parmPrinTypeID = @parmPrinTypeID, -- smallint
    @parmPrinAddedBy = @parmPrinAddedBy, -- int
    @parmPrinAddedOn = @parmPrinAddedOn, -- bigint
    @parmPrinUpdatedBy = @parmPrinAddedBy, -- int
    @parmPrinUpdatedOn = @parmPrinAddedOn, -- bigint
    @parmPrinPoolID = @parmPrinPoolID, -- int
    @parmPrinPolicyID = @parmPrinPolicyID, -- int
    @parmPrinID = @parmPrinID output
go
create procedure [dbo].[procInsertPrincipalAffiliationByID]
  @principalID int
 ,@affiliationIdList xml
 ,@skippedAffiliationList xml = null
 ,@updater integer
as 
  begin
	
    declare @skippedAffCount int
    declare @newAffiliationIds table
      (
       [index] int
      ,[entry] int
      )
    declare @skippedAffiliations table ([entry] nvarchar(256))
	    
    insert into
      @newAffiliationIds ([index], [entry])
      select
        [index]
       ,[entry]
      from
        fnParseDelimitedStringForIntWithIndex(@affiliationIdList) ids
    if (@skippedAffiliationList is not null) 
      begin
        insert into
          @skippedAffiliations ([entry])
          select
            [entry]
          from
            fnParseDelimitedStringForString(@skippedAffiliationList) ids
		        
        select
          @skippedAffCount = count(*)
        from
          @skippedAffiliations
      end
	
    set nocount on
    set transaction isolation level read committed
    declare
      @Tc int
     ,@Sp varchar(10)
    select
      @Tc = @@trancount
     ,@Sp = @@procid
    if (@Tc = 0) 
      begin
        set transaction isolation level read committed
        begin transaction @Sp
      end
    else 
      begin
        save transaction @Sp
      end
    begin try
			-- clear current affiliations, but not the self-affiliation
      delete from
        [tblPrincipalAffiliations]
      where
        [principalID] = @principalID
        and [index] <> -1
		
			-- insert new affiliations that were added
      insert into
        [tblPrincipalAffiliations]
        (
         [principalID]
        ,[affiliationID]
        ,[index]
        ,[updatedBy]
        )
        select
          @principalID
         ,ids.[entry]
         ,ids.[index]
         ,@updater
        from
          @newAffiliationIds ids
      delete from
        [tblSkippedAffiliations]
      where
        [prinID] = @principalID
		
			-- insert new skipped affiliations
      insert into
        [tblSkippedAffiliations]
        (
         [prinID]
        ,[affDescription]
        ,[updatedBy]
        )
        select
          @principalID
         ,ids.[entry]
         ,@updater
        from
          @skippedAffiliations ids
      declare
        @true bit
       ,@false bit
      select
        @true = 1
       ,@false = 0
      if (@skippedAffCount > 0) 
        begin
          if exists ( select
                        *
                      from
                        tblPrincipalMeta
                      where
                        prinID = @principalID ) 
            update
              tblPrincipalMeta
            set
              prinAffiliationsDirty = @true
             ,tryCount = tryCount + 1
             ,lastTry = getutcdate()
             ,nextTry = dateadd(hour, power(2, tryCount - 1), getutcdate())
            where
              prinID = @principalID
          else 
            insert into
              tblPrincipalMeta
              (
               prinID
              ,prinAffiliationsDirty
              ,prinAttributesDirty
              ,prinDeleted
              ,tryCount
              )
            values
              (
               @principalID
              ,@true
              ,@false
              ,@false
              ,1
              )
        end
      if (@Tc = 0) 
        commit transaction @Sp
    end try
    begin catch
      exec RethrowError
      if (xact_state() <> 0) 
        begin
          rollback transaction @Sp
          return -1
        end
    end catch
		
  end
go
create procedure [dbo].[procUpdatePrincipal]
  @parmUserID int
 ,@parmPrinName nvarchar(256)
 ,@parmPrinDispName nvarchar(256)
 ,@parmPrinCompany nvarchar(256)
 ,@parmPrinGuid nvarchar(80)
 ,@parmPrinUri nvarchar(256)
 ,@parmPrinEmail nvarchar(256)
 ,@parmPrinADPath nvarchar(384)
 ,@parmPrinADUserName nvarchar(256)
 ,@parmDisabled smallint
 ,@parmPrinTypeID smallint
 ,@parmPrinUpdatedBy int
 ,@parmPrinUpdatedOn bigint
 ,@parmPrinPoolID int
 ,@parmPrinPolicyID int
as 
begin transaction
  update
    [tblPrincipal]
  set
    [prinName] = @parmPrinName
   ,[prinDisplayName] = @parmPrinDispName
   ,[prinCompanyName] = @parmPrinCompany
   ,[prinGuid] = convert(uniqueidentifier, @parmPrinGuid)
   ,[prinUri] = @parmPrinUri
   ,[prinEmail] = @parmPrinEmail
   ,[prinADPath] = @parmPrinADPath
   ,[prinADUserPrincipalName] = @parmPrinADUserName
   ,[prinDisabled] = @parmDisabled
   ,[prinTypeID] = @parmPrinTypeID
   ,[prinUpdatedBy] = @parmPrinUpdatedBy
   ,[prinUpdatedOn] = @parmPrinUpdatedOn
   ,[prinPoolID] = @parmPrinPoolID
   ,[prinPolicyID] = @parmPrinPolicyID
  where
    [prinID] = @parmUserID
  if (@parmDisabled <> 0)
	  exec procOnPrincipalDisabled_p @parmUserID
		
if @@ERROR <> 0 
  rollback transaction
else 
  commit transaction
go
create procedure [dbo].[procOnPrincipalDisabled_p]
@parmUserID int
as
	delete from 
		tblPrincipalInvites
	where
		prinID = @parmUserID
		
	delete from 
		tblPrincipalMembers
	where
		prinID = @parmUserID
go
create procedure [dbo].[procUpdatePrincipal_p]
  @parmUserID int
 ,@parmPrinName nvarchar(256)
 ,@parmPrinDispName nvarchar(256)
 ,@parmPrinCompany nvarchar(256)
 ,@parmPrinGuid nvarchar(80)
 ,@parmPrinUri nvarchar(256)
 ,@parmPrinEmail nvarchar(256)
 ,@parmPrinADPath nvarchar(384)
 ,@parmPrinADUserName nvarchar(256)
 ,@parmDisabled smallint
 ,@parmPrinTypeID smallint
 ,@parmPrinAddedBy int
 ,@parmPrinAddedOn bigint
 ,@parmPrinUpdatedBy int
 ,@parmPrinUpdatedOn bigint
 ,@parmPrinPoolID int
 ,@parmPrinPolicyID int
as 
begin transaction
  update
    [tblPrincipal]
  set
    [prinName] = @parmPrinName
   ,[prinDisplayName] = @parmPrinDispName
   ,[prinCompanyName] = @parmPrinCompany
   ,[prinGuid] = convert(uniqueidentifier, @parmPrinGuid)
   ,[prinUri] = @parmPrinUri
   ,[prinEmail] = @parmPrinEmail
   ,[prinADPath] = @parmPrinADPath
   ,[prinADUserPrincipalName] = @parmPrinADUserName
   ,[prinDisabled] = @parmDisabled
   ,[prinTypeID] = @parmPrinTypeID
   ,[prinAddedBy] = @parmPrinAddedBy
   ,[prinAddedOn] = @parmPrinAddedOn
   ,[prinUpdatedBy] = @parmPrinUpdatedBy
   ,[prinUpdatedOn] = @parmPrinUpdatedOn
   ,[prinPoolID] = @parmPrinPoolID
   ,[prinPolicyID] = @parmPrinPolicyID  
  where
    [prinID] = @parmUserID
  if (@parmDisabled <> 0)
	exec procOnPrincipalDisabled_p @parmUserID
	
if @@ERROR <> 0 
  rollback transaction
else 
  commit transaction
go
create procedure [dbo].[procGetPrincipalByID] @parmPrinID int
as 
  set transaction isolation level read committed
  select
    p.[prinID]
   ,p.[prinName]
   ,p.[prinDisplayName]
   ,p.[prinCompanyName]
   ,p.[prinGuid]
   ,p.[prinUri]
   ,p.[prinEmail]
   ,p.[prinADPath]
   ,p.[prinADUserPrincipalName]
   ,p.[prinDisabled]
   ,p.[prinTypeID]
   ,p.[prinAddedOn]
   ,p.[prinAddedBy]
   ,a.[prinDisplayName] addedByDisplayName
   ,p.[prinUpdatedOn]
   ,p.[prinUpdatedBy]
   ,u.[prinDisplayName] updatedByDisplayName
   ,p.[prinPoolID]
   ,p.[prinPolicyID]
  from
    [tblPrincipal] p
    inner join [tblPrincipal] a on p.[prinAddedBy] = a.[prinID]
    inner join [tblPrincipal] u on p.[prinUpdatedBy] = u.[prinID]
  where
    p.[prinID] = @parmPrinID
go
create procedure [dbo].[procGetPrincipalByName]
  @parmPrinName nvarchar(256)
as 
  set transaction isolation level read committed
  select
    p.[prinID]
   ,p.[prinName]
   ,p.[prinDisplayName]
   ,p.[prinCompanyName]
   ,p.[prinGuid]
   ,p.[prinUri]
   ,p.[prinEmail]
   ,p.[prinADPath]
   ,p.[prinADUserPrincipalName]
   ,p.[prinDisabled]
   ,p.[prinTypeID]
   ,p.[prinAddedOn]
   ,p.[prinAddedBy]
   ,a.[prinDisplayName] addedByDisplayName
   ,p.[prinUpdatedOn]
   ,p.[prinUpdatedBy]
   ,u.[prinDisplayName] updatedByDisplayName
   ,p.[prinPoolID]
   ,p.[prinPolicyID]
  from
    [tblPrincipal] p
    inner join [tblPrincipal] a on p.[prinAddedBy] = a.[prinID]
    inner join [tblPrincipal] u on p.[prinUpdatedBy] = u.[prinID]
  where
    p.[prinName] = @parmPrinName
GO
create procedure [dbo].[procGetPrincipalByGuid]
  @parmPrinGuid nvarchar(80)
as 
  set transaction isolation level read committed
  select
    p.[prinID]
   ,p.[prinName]
   ,p.[prinDisplayName]
   ,p.[prinCompanyName]
   ,p.[prinGuid]
   ,p.[prinUri]
   ,p.[prinEmail]
   ,p.[prinADPath]
   ,p.[prinADUserPrincipalName]
   ,p.[prinDisabled]
   ,p.[prinTypeID]
   ,p.[prinAddedOn]
   ,p.[prinAddedBy]
   ,a.[prinDisplayName] addedByDisplayName
   ,p.[prinUpdatedOn]
   ,p.[prinUpdatedBy]
   ,u.[prinDisplayName] updatedByDisplayName
   ,p.[prinPoolID]
   ,p.[prinPolicyID]
  from
    [tblPrincipal] p
    inner join [tblPrincipal] a on p.[prinAddedBy] = a.[prinID]
    inner join [tblPrincipal] u on p.[prinUpdatedBy] = u.[prinID]
  where
    p.[prinGuid] = convert(uniqueidentifier, @parmPrinGuid)
GO
create procedure [dbo].[procGetPrincipalByUri]
  @parmPrinUri nvarchar(256)
as 
  set transaction isolation level read committed
  select
    p.[prinID]
   ,p.[prinName]
   ,p.[prinDisplayName]
   ,p.[prinCompanyName]
   ,p.[prinGuid]
   ,p.[prinUri]
   ,p.[prinEmail]
   ,p.[prinADPath]
   ,p.[prinADUserPrincipalName]
   ,p.[prinDisabled]
   ,p.[prinTypeID]
   ,p.[prinAddedOn]
   ,p.[prinAddedBy]
   ,a.[prinDisplayName] addedByDisplayName
   ,p.[prinUpdatedOn]
   ,p.[prinUpdatedBy]
   ,u.[prinDisplayName] updatedByDisplayName
   ,p.[prinPoolID]
   ,p.[prinPolicyID]  
  from
    [tblPrincipal] p
    inner join [tblPrincipal] a on p.[prinAddedBy] = a.[prinID]
    inner join [tblPrincipal] u on p.[prinUpdatedBy] = u.[prinID]
  where
    p.[prinUri] = @parmPrinUri
GO
create procedure [dbo].[procGetComplianceUsers] @xml xml
as 
  set transaction isolation level read committed
  select
    p.[prinID]
   ,p.[prinUri]
   ,p.[prinEmail]
   ,p.[prinTypeID]
   ,p.[prinName]
  from
    [tblPrincipal] p
    inner join fnParseDelimitedStringForInt(@xml) ids on p.[prinID] = ids.entry
GO
CREATE procedure [dbo].[procBulkGetMaxPreference]
  (
   @xml xml
  )
as 
	declare @map table (
		i int identity
		,prefLabel nvarchar(255)
		,reqSeqId int
	)
	insert
		@map
	select
		r.value('@k', 'nvarchar(255)')
		,r.value('@v', 'int')
	from 
		@xml.nodes('ROOT/r') item (r)		
  	
  	--create a table to hold the maxSeqId and newSeqId for a given label
  	
  	declare @maxSeqIdMap table (
		prefLabel nvarchar(512)
		,maxSeqId int
		,newSeqId int
	)
	
  	insert into
  		@maxSeqIdMap
  	select
		p.prefLabel prefLabel
		,max(prefSeqID) maxSeqId
		,max(prefSeqID) newSeqId
	from
		@map m
		inner join tblPreference p on m.prefLabel = p.prefLabel
    group by
		p.prefLabel
		--if seqId is less than maxSeqID, user is attempting to save old pref
		--if seqId is greater than maxSeqID, pref is from another database
    update
        @maxSeqIdMap
    set
        newSeqId = a.maxSeqId + 1
    from
		@maxSeqIdMap a
		inner join @map m on m.prefLabel = a.prefLabel
	where
		a.maxSeqId <> m.reqSeqId
				
    update
        tblPreference
    set
        [prefSeqID] = a.newSeqId
    from
		@maxSeqIdMap a
		inner join tblPreference b on a.prefLabel = b.prefLabel
	where
		(a.newSeqId <> b.prefSeqID)
  	
  	--return 
  		--the result of the batch request ordered by the request index i
  		--the content for the given labels only if the max seqId for a label is greater than the seqId supplied.
  	
  select
   m.i
   ,p.[prefLabel]
   ,p.[prefSeqID]
   ,p.[prefContent]
  from
    @map m
    left outer join @maxSeqIdMap b on m.prefLabel = b.prefLabel
    left outer join tblPreference p on m.prefLabel = p.prefLabel 
										and b.newSeqId = p.prefSeqID
										and p.prefSeqID <> m.reqSeqId
  order by
	m.i
go
create procedure [dbo].procSetPreference_p
  (
   @label nvarchar(255)
  ,@seqId int out
  ,@content nvarchar(max)
  ,@updater int
  )
as 
  declare @maxSeqID int
  select
    @maxSeqID = max(prefSeqID)
  from
    tblPreference
  where
    prefLabel = @label    
  if @maxSeqID is not null 
    begin
			--if @seqId is less than @maxSeqID, user is attempting to save old pref
			--if @seqId is greater than @maxSeqID, pref is from another database
      if @maxSeqID != @seqId 
        begin
          raiserror (50291, 16, 1, @maxSeqID, @seqId)
          return -1
        end
      set @seqId = @maxSeqID + 1
    end
	
  if @maxSeqID is null 
    insert into
      tblPreference
    values
      (
       @label
      ,@seqId
      ,@content
      ,@updater
      )
  else 
    update
      tblPreference
    set
      prefContent = @content
     ,prefSeqID = @seqId
     ,lastModifiedBy = @updater
    where
      prefLabel = @label
go
create procedure [dbo].procInsertPreference
  (
   @label nvarchar(255)
  ,@content nvarchar(max)
  ,@updater int
  ,@seqId int = 1 out --takes existing seq id.  returns the new seqId
  )
as 
  if @seqId < 1 
    set @seqId = 1
  exec procSetPreference_p @label = @label, @seqId = @seqId out, @content = @content, @updater = @updater
go
create procedure [dbo].[procGetRootNodeIds]
  @nodeGuid uniqueidentifier output
 ,@nodeDbId int output
as 
  set transaction isolation level read committed
  select
    @nodeGuid = [nodeGuid]
   ,@nodeDbId = nodeID
  from
    [tblNode]
  where
    [parentID] is null
go
create procedure [dbo].[procGetNodeByGuid]
  @guid uniqueidentifier
as 
  set transaction isolation level read committed
  declare @nodeID int
  select
    @nodeID = [nodeID]
  from
    [tblNode]
  where
    [nodeGuid] = @guid
  select
    n.[nodeID]
   ,n.[nodeGuid]
   ,n.[parentID]
   ,p.[nodeGuid] parentGuid
   ,n.[nodeType]
   ,n.[nodeName]
   ,n.[nodeDesc]
   ,n.[behavior]
   ,n.[nodeAddedBy]
   ,n.[nodeAddedOn]
   ,a.[prinDisplayName] addedByDisplayName
   ,n.[nodeUpdatedBy]
   ,n.[nodeUpdatedOn]
   ,u.[prinDisplayName] updatedByDisplayName
   ,n.[visibility]
   ,n.[invite]
   ,n.[logged]
   ,n.[filePost]
   ,n.[disabled]
   ,si.[siopID]
   ,si.[siopName]
   ,si.[siopUrl]
  from
    [tblNode] n
    left outer join [tblNode] p on n.[parentID] = p.[nodeID]
    left outer join [tblSiopWhiteList] si on n.[siopID] = si.[siopID]
    inner join [tblPrincipal] a on n.[nodeAddedBy] = a.[prinID]
    inner join [tblPrincipal] u on n.[nodeUpdatedBy] = u.[prinID]
  where
    n.[nodeID] = @nodeID
  exec procGetScopeForNode_p @nodeID
  exec procGetRolesForNode_p @nodeID
go
create procedure [dbo].[procGetScopeForNode_p]
  @nodeID int
as 
  select
    s.[nodeID]
   ,s.[prinID]
   ,s.[prinUri]
   ,s.[isDenied]
  from
    [vwScope_EffectiveNode_ExplicitPrincipal_p] s
  where
    s.[nodeID] = @nodeID
GO
create procedure [dbo].[procGetScopeForNodes_p]
  @xml xml
as 
  declare @nodeIDs table ([id] int)
  insert into
    @nodeIDs
    select
      [entry]
    from
      fnParseDelimitedStringForInt(@xml)
  set transaction isolation level read committed
  select
    s.[nodeID]
   ,s.[prinID]
   ,s.[prinUri]
   ,s.[isDenied]
  from
    [vwScope_EffectiveNode_ExplicitPrincipal_p] s
    inner join @nodeIDs ids on ids.[id] = s.[nodeID]   
GO
create procedure [dbo].[procGetNodeByName]
  @parm_nodename nvarchar(256)
as 
  set transaction isolation level read committed
  declare @nodeID int
  select
    @nodeID = [nodeID]
  from
    [tblNode]
  where
    [nodeName] = @parm_nodename
  select
    n.[nodeID]
   ,n.[nodeGuid]
   ,n.[parentID]
   ,p.[nodeGuid] parentGuid
   ,n.[nodeType]
   ,n.[nodeName]
   ,n.[nodeDesc]
   ,n.[behavior]
   ,n.[nodeAddedBy]
   ,n.[nodeAddedOn]
   ,a.[prinDisplayName] addedByDisplayName
   ,n.[nodeUpdatedBy]
   ,n.[nodeUpdatedOn]
   ,u.[prinDisplayName] updatedByDisplayName
   ,n.[visibility]
   ,n.[invite]
   ,n.[logged]
   ,n.[filePost]
   ,n.[disabled]
   ,si.[siopID]
   ,si.[siopName]
   ,si.[siopUrl]
  from
    [tblNode] n
    left outer join [tblNode] p on n.[parentID] = p.[nodeID]
    left outer join [tblSiopWhiteList] si on n.[siopID] = si.[siopID]
    inner join [tblPrincipal] a on n.[nodeAddedBy] = a.[prinID]
    inner join [tblPrincipal] u on n.[nodeUpdatedBy] = u.[prinID]
  where
    n.[nodeID] = @nodeID
  exec procGetScopeForNode_p @nodeID
  exec procGetRolesForNode_p @nodeID
go
create procedure [dbo].[procGetNodesWithPrinListsByID] @xml xml
as 
  declare @nodeIDs table ([id] int)
  insert into
    @nodeIDs
    select
      [entry]
    from
      fnParseDelimitedStringForInt(@xml)
  set transaction isolation level read committed
  select
    n.[nodeID]
   ,n.[nodeGuid]
   ,n.[parentID]
   ,p.[nodeGuid] parentGuid
   ,n.[nodeType]
   ,n.[nodeName]
   ,n.[nodeDesc]
   ,n.[behavior]
   ,n.[nodeAddedBy]
   ,n.[nodeAddedOn]
   ,a.[prinDisplayName] addedByDisplayName
   ,n.[nodeUpdatedBy]
   ,n.[nodeUpdatedOn]
   ,u.[prinDisplayName] updatedByDisplayName
   ,n.[visibility]
   ,n.[invite]
   ,n.[logged]
   ,n.[filePost]
   ,n.[disabled]
   ,si.[siopID]
   ,si.[siopName]
   ,si.[siopUrl]
  from
    @nodeIDs nodes
    inner join [tblNode] n on n.[nodeID] = nodes.id
    left outer join [tblNode] p on n.[parentID] = p.[nodeID]
    left outer join [tblSiopWhiteList] si on n.[siopID] = si.[siopID]
    inner join [tblPrincipal] a on n.[nodeAddedBy] = a.[prinID]
    inner join [tblPrincipal] u on n.[nodeUpdatedBy] = u.[prinID]
  exec procGetScopeForNodes_p @xml
  exec procGetRolesForNodes_p @xml
go
create procedure [dbo].[procGetScopeAndRoleLists] @xml xml
as    
  exec procGetScopeForNodes_p @xml
  exec procGetRolesForNodes_p @xml  
go
create procedure [dbo].[procInsertNode_p]
  @parm_nodeID uniqueidentifier
 ,@parm_parentID int
 ,@parm_nodeType bit
 ,@parm_nodeName nvarchar(256)
 ,@parm_nodeDesc nvarchar(256)
 ,@parm_behavior smallint
 ,@parm_nodeAddedBy int
 ,@parm_nodeAddedOn bigint
 ,@parm_nodeUpdatedBy int
 ,@parm_nodeUpdatedOn bigint
 ,@parm_visibility smallint
 ,@parm_invite bit
 ,@parm_logged bit
 ,@parm_filePost bit
 ,@parm_disabled bit
 ,@parm_siopID uniqueidentifier
 ,@parm_dbId int = 0 output
as 
  set nocount on
  if @parm_parentID > 0 
    begin
      declare @var_nodeID int
      declare @var_nodeExists bit
      declare @var_nodeType bit
      declare @var_nodeName nvarchar(256)
      declare @var_error int
      select
        @var_nodeID = nodeID
       ,@var_nodeType = nodeType
       ,@var_nodeName = nodeName
       ,@var_nodeExists = 1
      from
        tblNode
      where
        nodeID = @parm_parentID
      if @var_nodeExists = 1
        if @var_nodeType <> 1 -- Parent is not a category (including root)
          select @var_error = 50300
        else if @parm_nodeType = 1 and @var_nodeID <> 1 -- Parent of category is not root (we don't support nesting)
          select @var_error = 50302
        else if @parm_nodeType <> 1 and @var_nodeID = 1 -- Parent of channel is root
          select @var_error = 50303
        if @var_error > 0
        begin
          declare
            @parentNodeName nvarchar(256)
           ,@parentNodeId nvarchar(36)
          select
            @parentNodeName = nodeName
           ,@parentNodeId = [nodeGuid]
          from
            [tblNode]
          where
            [nodeID] = @parm_parentID
          raiserror (@var_error, 16, 1, @parentNodeName, @parentNodeId)
          return -1
        end                
    end
  declare
    @Tc int
   ,@Sp varchar(10)
  if (@parm_nodeType = 1) 
    begin
      select
        @parm_behavior = 4
       ,@parm_disabled = 0
       ,@parm_visibility = 3
    end  
  select
    @Tc = @@trancount
   ,@Sp = @@procid
  if (@Tc = 0) 
    begin
      set transaction isolation level read committed
      begin transaction @Sp
    end
  else 
    begin
      save transaction @Sp
    end
  begin try
    insert into
      [tblNode]
      (
       nodeGuid
      ,parentID
      ,nodeType
      ,nodeName
      ,nodeDesc
      ,behavior
      ,nodeAddedBy
      ,nodeAddedOn
      ,nodeUpdatedBy
      ,nodeUpdatedOn
      ,visibility
      ,invite
      ,logged
      ,filePost
      ,[disabled]
      ,siopID
      )
    values
      (
       @parm_nodeID
      ,@parm_parentID
      ,@parm_nodeType
      ,@parm_nodeName
      ,@parm_nodeDesc
      ,@parm_behavior
      ,@parm_nodeAddedBy
      ,@parm_nodeAddedOn
      ,@parm_nodeUpdatedBy
      ,@parm_nodeUpdatedOn
      ,@parm_visibility
      ,@parm_invite
      ,@parm_logged
      ,@parm_filePost
      ,@parm_disabled
      ,@parm_siopID
      )
    set @parm_dbId = scope_identity()
    if (@Tc = 0) 
      commit transaction @Sp
  end try
  begin catch
    exec RethrowError
    if (xact_state() <> 0) 
      begin
        rollback transaction @Sp
        return -1
      end
  end catch
GO
create procedure [dbo].[procInsertNode]
  @parm_parentID int
 ,@parm_nodeType bit
 ,@parm_nodeName nvarchar(256)
 ,@parm_nodeDesc nvarchar(256)
 ,@parm_behavior smallint
 ,@parm_nodeAddedBy int
 ,@parm_nodeAddedOn bigint
 ,@parm_visibility smallint
 ,@parm_invite bit
 ,@parm_logged bit
 ,@parm_filePost bit
 ,@parm_disabled bit
 ,@parm_siopID uniqueidentifier
 ,@parm_dbId int = 0 output
 ,@parm_nodeID uniqueidentifier = null output
as 
  set @parm_nodeID = newid()
  exec [procInsertNode_p] @parm_nodeID = @parm_nodeID, -- uniqueidentifier
    @parm_parentID = @parm_parentID, -- int
    @parm_nodeType = @parm_nodeType, -- bit
    @parm_nodeName = @parm_nodeName, -- nvarchar(256)
    @parm_nodeDesc = @parm_nodeDesc, -- nvarchar(256)
    @parm_behavior = @parm_behavior, -- smallint
    @parm_nodeAddedBy = @parm_nodeAddedBy, -- int
    @parm_nodeAddedOn = @parm_nodeAddedOn, -- bigint
    @parm_nodeUpdatedBy = @parm_nodeAddedBy, -- int
    @parm_nodeUpdatedOn = @parm_nodeAddedOn, -- bigint
    @parm_visibility = @parm_visibility, -- smallint
    @parm_invite = @parm_invite, -- bit
    @parm_logged = @parm_logged, -- bit
    @parm_filePost = @parm_filePost, -- bit
    @parm_disabled = @parm_disabled, -- bit
    @parm_siopID = @parm_siopID, --uniqueidentifier
    @parm_dbId = @parm_dbId output -- int
go
create procedure [dbo].[procUpdateNode]
  @parm_dbId int
 ,@parm_parentID int
 ,@parm_nodeType bit
 ,@parm_nodeName nvarchar(256)
 ,@parm_nodeDesc nvarchar(256)
 ,@parm_behavior smallint
 ,@parm_nodeUpdatedBy int
 ,@parm_nodeUpdatedOn bigint
 ,@parm_visibility smallint
 ,@parm_invite bit
 ,@parm_logged bit
 ,@parm_filePost bit
 ,@parm_disabled bit
 ,@parm_siopID uniqueidentifier
as 
  set nocount on
  if @parm_parentID = 0 
    begin
      set @parm_parentID = null
    end
  if @parm_parentID > 0 
    begin
      declare @var_nodeID int
      declare @var_parentID int
      declare @var_nodeExists bit
      declare @var_nodeType bit
      declare @var_nodeName nvarchar(256)
      declare @var_error int
      select
        @var_nodeID = nodeID
       ,@var_parentID = parentID
       ,@var_nodeType = nodeType
       ,@var_nodeName = nodeName
       ,@var_nodeExists = 1
      from
        tblNode
      where
        nodeID = @parm_parentID
      if @var_nodeExists = 1
        if @var_parentID = @parm_dbId
          select @var_error = 50301     
        else if @var_nodeType <> 1 -- Parent is not a category (including root)
          select @var_error = 50300
        else if @parm_nodeType = 1 and @var_nodeID <> 1 -- Parent of category is not root (we don't support nesting)
          select @var_error = 50302
        else if @parm_nodeType <> 1 and @var_nodeID = 1 -- Parent of channel is root
          select @var_error = 50303
        if @var_error > 0
        begin
          declare
            @parentNodeName nvarchar(256)
           ,@parentNodeId nvarchar(36)
          select
            @parentNodeName = nodeName
           ,@parentNodeId = [nodeGuid]
          from
            [tblNode]
          where
            [nodeID] = @parm_parentID
          raiserror (@var_error, 16, 2, @parentNodeName, @parentNodeId)
          return -1
        end                
    end
  if (@parm_nodeType = 1) 
    begin
      select
        @parm_behavior = 4
       ,@parm_disabled = 0
       ,@parm_visibility = 3
    end 
  set nocount on
  declare
    @Tc int
   ,@Sp varchar(10)
  select
    @Tc = @@trancount
   ,@Sp = @@procid
  if (@Tc = 0) 
    begin
      set transaction isolation level read committed
      begin transaction @Sp
    end
  else 
    begin
      save transaction @Sp
    end
  declare @deleted table
    (
     parentID int
    )
  begin try
    update
      [tblNode]
    set
      [parentID] = @parm_parentID
     ,[nodeType] = @parm_nodeType
     ,[nodeName] = @parm_nodeName
     ,[nodeDesc] = @parm_nodeDesc
     ,[behavior] = @parm_behavior
     ,[nodeUpdatedBy] = @parm_nodeUpdatedBy
     ,[nodeUpdatedOn] = @parm_nodeUpdatedOn
     ,[visibility] = @parm_visibility
     ,[invite] = @parm_invite
     ,[logged] = @parm_logged
     ,[filePost] = @parm_filePost
     ,[disabled] = @parm_disabled
     ,[siopID] = @parm_siopID
    output
      deleted.parentID
      into @deleted
    where
      [nodeID] = @parm_dbId
    declare @affectedNodes table (id int)
    if @parm_parentID <> (
                          select [parentID] from @deleted
                         ) 
      begin      
        insert into
          @affectedNodes ([id])
          select
            [nodeID] nodeID
          from
            [tblNode]
          where
            [parentID] = @parm_dbId
      end
    select distinct
      [id]
    from
      @affectedNodes
    if (@Tc = 0) 
    begin
      commit transaction @Sp
      return 0
    end
  end try
  begin catch
    exec RethrowError
    if (xact_state() <> 0) 
      begin
        rollback transaction @Sp
        return -1
      end
  end catch
go
create procedure [dbo].[procUpdateNodeFull]
 @nodeType bit,
 @parm_dbId int,
 @parm_parentID int,
 @parm_nodeType bit,
 @parm_nodeName nvarchar(256),
 @parm_nodeDesc nvarchar(256),
 @parm_behavior smallint,
 @parm_nodeUpdatedBy int,
 @parm_nodeUpdatedOn bigint,
 @parm_visibility smallint,
 @parm_invite bit,
 @parm_logged bit,
 @parm_filePost bit,
 @parm_disabled bit,
 @parm_siopID uniqueidentifier,
 @parm_scopeUris ntext,
 @creatorRoleId int,
 @parm_creatorReplaceUris xml,
 @parm_creatorAddUris xml,
 @parm_creatorRemoveUris xml,
 @memRoleId int,
 @parm_memReplaceUris xml,
 @parm_memAddUris xml,
 @parm_memRemoveUris xml,
 @mgrRoleId int,
 @parm_mgrReplaceUris xml,
 @parm_mgrAddUris xml,
 @parm_mgrRemoveUris xml,
 @presenterRoleId int,
 @parm_preReplaceUris xml,
 @parm_preAddUris xml,
 @parm_preRemoveUris xml,
 @parm_reparent int,
 @updater int
as
    set transaction isolation level read committed
    declare @errMsgs table (
        [errCode] int,
        [uris] nvarchar(max) collate Latin1_General_CI_AS
    )
    declare @tmpNodeIdHolder table ( [id] int )
    declare @tmpUriHolder table ( [prinUri] nvarchar(256) )
    declare @updateSP nvarchar(10) = @@procid
    begin transaction @updateSP
    declare @succ int = 0
    begin try
        insert into @tmpNodeIdHolder
            exec @succ = [dbo].[procUpdateNode]
                @parm_dbId, @parm_parentID, @parm_nodeType, @parm_nodeName,
                @parm_nodeDesc, @parm_behavior, @parm_nodeUpdatedBy,
                @parm_nodeUpdatedOn, @parm_visibility, @parm_invite,
                @parm_logged, @parm_filePost, @parm_disabled, @parm_siopID
        if (@@error <> 0 or @succ <> 0)
        begin
            rollback transaction @updateSP
            return -1
        end
        if (@parm_reparent <> 0)
        begin
            insert into @tmpNodeIdHolder
                exec [dbo].[procPurgeRolesNoLongerInScope]
                    @parm_dbId
            if (@@error <> 0)
            begin
                rollback transaction @updateSP
                return -1
            end
        end
        if (@nodeType = 1 and @parm_scopeUris is not null)
        begin
            exec @succ = [dbo].[procSetScope]
                @parm_dbId, @parm_scopeUris, @updater
            if (@@error <> 0 or @succ <> 0)
            begin
                rollback transaction @updateSP
                return -1
            end
            insert into @tmpNodeIdHolder
                exec [dbo].[procPurgeRolesNoLongerInScope]
                    @parm_dbId
            if (@@error <> 0)
            begin
                rollback transaction @updateSP
                return -1
            end
        end
        insert into @errMsgs
            exec @succ = [dbo].[procUpdateRoleHelper]
                @parm_dbId, @creatorRoleId, @parm_creatorReplaceUris, 
                @parm_creatorAddUris, @parm_creatorRemoveUris,
                @parm_nodeUpdatedBy
        if (@@error <> 0 or @succ = -1)
        begin
            select * from @errMsgs
            rollback transaction @updateSP
            return -1
        end
        insert into @errMsgs
            exec @succ = [dbo].[procUpdateRoleHelper]
                @parm_dbId, @memRoleId, @parm_memReplaceUris, 
                @parm_memAddUris, @parm_memRemoveUris,
                @parm_nodeUpdatedBy
        if (@@error <> 0 or @succ = -1)
        begin
            select * from @errMsgs
            rollback transaction @updateSP
            return -1
        end
        if (@parm_visibility != 6)
        begin
            insert into @tmpUriHolder
                exec [dbo].[procPurgeVoicedRolesNoLongerInMemberScope]
                    @parm_dbId
            if (@@error <> 0)
            begin
                select * from @errMsgs
                rollback transaction @updateSP
                return -1
            end
        end
        insert into @errMsgs
            exec @succ = [dbo].[procUpdateRoleHelper]
                @parm_dbId, @mgrRoleId, @parm_mgrReplaceUris, 
                @parm_mgrAddUris, @parm_mgrRemoveUris,
                @parm_nodeUpdatedBy
        if (@@error <> 0 or @succ = -1)
        begin
            select * from @errMsgs
            rollback transaction @updateSP
            return -1
        end
        insert into @errMsgs
            exec @succ = [dbo].[procUpdateRoleHelper]
                @parm_dbId, @presenterRoleId, @parm_preReplaceUris, 
                @parm_preAddUris, @parm_preRemoveUris,
                @parm_nodeUpdatedBy
        if (@@error <> 0 or @succ = -1)
        begin
            select * from @errMsgs
            rollback transaction @updateSP
            return -1
        end
    end try
    begin catch
        exec RethrowError
        select * from @errMsgs
        rollback transaction @updateSP
        return -1
    end catch
    select * from @errMsgs
    commit transaction @updateSP
go
create procedure [dbo].[procGetNodeChildren] @parmNodeID int
as 
  set transaction isolation level read committed
  select
    [nodeID]
   ,[nodeGuid]
   ,[nodeName]
   ,[nodeType]
  from
    [tblNode]
  where
    [parentID] = @parmNodeID
GO
create procedure [dbo].[procGetCategoryChildrenCount] @parmCatId int
AS
    set transaction isolation level read committed
    select count(nodeID)
    from tblNode
    where parentID = @parmCatId
GO
create procedure [dbo].[procSearchForNodes]
 @parm_node_type bit
,@parm_criteria xml
,@parm_also_description bit
,@parm_matchAll bit
as 
    set transaction isolation level read committed  
  select
    [nodeID]
  from
    [tblNode] n
    cross join fnParseXmlForStringsEscapedForUseWithLike(@parm_criteria) c
  where
    [nodeType] = @parm_node_type
  group by [nodeID]
  having case when @parm_matchAll <> 0 then count(1)   
              else 1                                  
        end <= sum(case when [nodeName] collate Latin1_General_CI_AS like '%' + c.entry + '%' ESCAPE '!'
                           or (@parm_also_description = 1 and [nodeDesc] collate Latin1_General_CI_AS like '%' + c.entry + '%' ESCAPE '!')
                         then 1 
                         else 0 
                    end)
go
create procedure [dbo].[procFilterNodes]
 @parm_node_type int,
 @parm_criteria xml,
 @parm_also_description bit,
 @paramMemPrin nvarchar(250) = null,
 @paramMgrPrin nvarchar(250) = null,
 @categoryGuid uniqueidentifier = null,
 @addinGuid uniqueidentifier = null,
 @disabled bit = null,
 @vis smallint = null,
 @type smallint = null,
 @invites bit = 0,
 @searchInvites bit = 0,
 @parm_matchAll bit,
 @parm_exceedsMB int,
 @parm_startIndex int,
 @parm_maxresults int
as
  set transaction isolation level read committed
  declare @categoryID int = case when @categoryGuid is null then -1 
                             else (select nodeID from tblNode n where nodeGuid = @categoryGuid) end
  declare @memPrinID int = case when @paramMemPrin is null then -1
                             else (select p.prinID from tblPrincipal p where p.prinUri = @paramMemPrin) end
  declare @mgrPrinID int = case when @paramMgrPrin is null then -1
                             else (select p.prinID from tblPrincipal p where p.prinUri = @paramMgrPrin) end
      ;
  with OrderedResults as (
    select distinct n.nodeID, n.nodeName, ROW_NUMBER() over(order by nodeName asc) as RowID
    from tblNode n
            cross join fnParseXmlForStringsEscapedForUseWithLike(@parm_criteria) c
    where nodeType = @parm_node_type and
            (@paramMemPrin is null or (@paramMemPrin = '' and n.nodeID not in (select roles.prinRoleNodeID
                                                                               from tblPrincipalRole roles
                                                                               where roles.prinRoleTypeID = 1))
                                   or (n.nodeID in (select innerN.nodeID
                                                    from tblNode innerN
                                                        inner join tblPrincipalRole roles on innerN.nodeID = roles.prinRoleNodeID
                                                                                            and roles.prinRoleTypeID = 1
                                                        inner join tblPrincipalAffiliations pa on roles.prinRolePrinID = pa.affiliationID
                                                        inner join tblPrincipal p on pa.principalID = p.prinID and p.prinDisabled = 0
                                                        inner join tblPrincipal pav on pa.affiliationID = pav.prinID and pav.prinDisabled = 0
                                                    where n.nodeType = @parm_node_type and
                                                          @memPrinID = p.prinID))) and
            (@paramMgrPrin is null or (@paramMgrPrin = '' and n.nodeID not in (select roles.prinRoleNodeID
                                                                               from tblPrincipalRole roles
                                                                               where roles.prinRoleTypeID = 2))
                                   or (n.nodeID in (select innerN.nodeID
                                                    from tblNode innerN
                                                        inner join tblPrincipalRole roles on innerN.nodeID = roles.prinRoleNodeID
                                                                                            and roles.prinRoleTypeID = 2
                                                        inner join tblPrincipalAffiliations pa on roles.prinRolePrinID = pa.affiliationID
                                                        inner join tblPrincipal p on pa.principalID = p.prinID and p.prinDisabled = 0
                                                        inner join tblPrincipal pav on pa.affiliationID = pav.prinID and pav.prinDisabled = 0
                                                    where n.nodeType = @parm_node_type and
                                                          @mgrPrinID = p.prinID))) and
            (@categoryGuid is null or n.parentID = @categoryID) and
            (@addinGuid is null or n.siopID = @addinGuid) and
            (@disabled is null or n.disabled = @disabled) and
            (@vis is null or n.visibility = @vis) and
            (@type is null or n.behavior = @type) and
            (@searchInvites = 0 or (n.invite = @invites or (@invites is null and n.invite is null))) and
            (@parm_exceedsMB < 0 or n.nodeID in 
                        (select channelId from tblChat
                            group by channelId
                            having sum(2*len(content) + (case when rtf is null then 0 else len(rtf) end))/1000000 > @parm_exceedsMB))
    group by n.nodeID, n.nodeName
    having case when @parm_matchAll <> 0 then count(1) 
                        else 1                                  
                        end <= sum(case when n.nodeName collate Latin1_General_CI_AS like '%' + c.entry + '%' ESCAPE '!'
                            or (@parm_also_description = 1 and n.nodeDesc collate Latin1_General_CI_AS like '%' + c.entry + '%' ESCAPE '!')
                            then 1 else 0 end)        
) 
        select [nodeID]
        from OrderedResults 
        where RowID between @parm_startIndex + 1 
                     and @parm_startIndex + @parm_maxresults  
go
create procedure [dbo].[procGetAllChildChannelIDs] @parm_dbId int
as 
  set transaction isolation level read committed
  declare @parentID int
  select @parentID = parentID from tblNode where nodeID = @parm_dbId
  if @@rowcount > 0 and @parentID is null 
    select 
      n.nodeID as [id]
    from
      tblNode n
    where 
      n.nodeType = 0  
  else
    select 
      n.nodeID as [id]
    from
      tblNode n
    where
      n.parentID = @parm_dbId and
      n.nodeType = 0 
GO
create procedure [dbo].[procGetAllChildNodeIDs] @parm_dbId int
as 
  set transaction isolation level read committed
  declare @parentID int
  select @parentID = parentID from tblNode where nodeID = @parm_dbId
  if @@rowcount > 0 and @parentID is null 
    select 
      n.nodeID as [id]
    from
      tblNode n
    where 
      n.parentID is not null    
  else
    select 
      n.nodeID as [id]
    from
      tblNode n
    where
      n.parentID = @parm_dbId
GO
create procedure [dbo].[procGetNodeWithParents] @parm_dbId int
as 
  set transaction isolation level read committed
  set nocount on
  declare @nodeIDs table ([id] int, [index] int)
  declare @index int
  set @index = 0
  declare @crtNodeId int
  set @crtNodeId = @parm_dbId
  declare @crtParentId int
  while @crtNodeId is not null
    begin
      insert into
        @nodeIDs
      select 
        [id] = @crtNodeId
       ,[index] = @index
      set @index = @index + 1
      set @crtParentId = null
      select 
        @crtParentId = parentID
      from 
        tblNode
      where 
        nodeID = @crtNodeId  
      set @crtNodeId = @crtParentId
    end
  select
    n.[nodeID]
   ,n.[nodeGuid]
   ,n.[nodeType]
  from
    [tblNode] n
    inner join @nodeIDs as ids on n.nodeID = ids.id
  order by
    ids.[index]
GO
create procedure [dbo].[procDeleteCategory]
  @parm_categoryID int
as 
  delete from
    [tblPrincipalRole]
  where
    [prinRoleNodeID] = @parm_categoryID
  delete from
    [tblScopedPrincipal]
  where
    [scopeNodeID] = @parm_categoryID
  delete from
    [tblNode]
  where
    [nodeID] = @parm_categoryID
go
create procedure [dbo].[procDeleteChannel]
  @parm_channelID int
as 
  delete from 
    [tblChat]
  where
    [channelId] = @parm_channelID
  delete from 
    [tblFileToken]
  where
    [fileTokenChannelID] in 
        (select [nodeGuid] from [tblNode] where [nodeID] = @parm_channelID)
  delete from
    [tblPrincipalRole]
  where
    [prinRoleNodeID] = @parm_channelID
  delete from 
    [tblPrincipalInvites]
  where 
    [nodeID]  = @parm_channelID
  delete from 
    [tblLastChatId]
  where 
    [nodeID]  = @parm_channelID
  delete from
    [tblNode]
  where
    [nodeID] = @parm_channelID
go
create procedure [dbo].[procPurgeChannel]
  @parm_nodeID int
 ,@parm_upToDate bigint
 ,@parm_noCommit bit
as 
  set nocount on
  declare @purgedCount int
  declare @purgedMB int
  declare @leftCount int
  declare @leftMB int
  select 
    @purgedCount = COUNT(*)
   ,@purgedMB = sum(2*len(content) + (case when rtf is null then 0 else len(rtf) end))/1000000
  from
    tblChat
  where
    channelId = @parm_nodeID and
    chatDate < @parm_upToDate
  if (@parm_noCommit = 0)
  begin
    delete from tblChat
    where
      channelId = @parm_nodeID and
      chatDate < @parm_upToDate
    select 
      @leftCount = COUNT(*)
     ,@leftMB = sum(2*len(content) + (case when rtf is null then 0 else len(rtf) end))/1000000
    from
      tblChat
    where
      channelId = @parm_nodeID     
  end
  else
    select 
      @leftCount = COUNT(*)
     ,@leftMB = sum(2*len(content) + (case when rtf is null then 0 else len(rtf) end))/1000000
    from
      tblChat
    where
      channelId = @parm_nodeID and
      chatDate >= @parm_upToDate 
  declare @results table
  (
    PurgedCount int,
    PurgedMB int,
    LeftCount int,
    LeftMB int
  )
  if (@purgedCount = 0) set @purgedMB = 0
  if (@leftCount = 0) set @leftMB = 0
  insert into @results (PurgedCount, PurgedMB, LeftCount, LeftMB)
    values (@purgedCount, @purgedMB, @leftCount, @leftMB)
  select * from @results
go
create procedure [dbo].[procGetSiopWhiteList]
as 
  set transaction isolation level read committed
  select
    siopID
    ,siopName
    ,siopUrl
  from
    tblSiopWhiteList
go
create procedure [dbo].[procGetSiopChannelList]
  @parm_siopID uniqueidentifier
as 
  set transaction isolation level read committed
  select
    nodeID
  from
    tblNode 
  where 
    siopID = @parm_siopID
go
create procedure [dbo].[procInsertSiop]
    @siopID uniqueidentifier
    ,@siopName nvarchar(50)
    ,@siopUrl nvarchar(255)
as 
  if exists (select * from tblSiopWhiteList where siopID = @siopID)
    begin
      declare @siopIDString nvarchar(50)
      set @siopIDString = convert(nvarchar(50), @siopID)
      raiserror (50341, 16, 1, @siopIDString)
      return -1
    end
  if exists (select * from tblSiopWhiteList where siopName = @siopName)
    begin
      raiserror (50340, 16, 1, @siopName)
      return -1
    end
  insert into 
    tblSiopWhiteList (
    siopID
    ,siopName
    ,siopUrl)
    values (
    @siopID
    ,@siopName
    ,@siopUrl
    )
go
create procedure [dbo].[procUpdateSiop]
    @siopID uniqueidentifier
    ,@siopName nvarchar(50)
    ,@siopUrl nvarchar(255)
as 
  if exists (select * from tblSiopWhiteList where siopID <> @siopID and siopName = @siopName)
    begin
      raiserror (50340, 16, 1, @siopName)
      return -1
    end
  select nodeID from tblNode where siopID = @siopID
  update
    tblSiopWhiteList 
  set
    siopName = @siopName,
    siopUrl = @siopUrl
  where 
    siopID = @siopID
go
create procedure [dbo].[procDeleteSiop]
    @siopID uniqueidentifier
as
  select nodeID from tblNode where siopID = @siopID 
  update tblNode set siopID = null where siopID = @siopID
  delete from
    tblSiopWhiteList 
  where 
    siopID = @siopID
go
	
go
create view [dbo].[vwScope_ScopeDefiners]
as
  select 
    n.[nodeID] nodeID,
    n.[nodeID] definerID
  from
    [tblNode] n
  where
    n.[nodeType] = 1
  union all
  select
    n.[nodeID] nodeID,
    p.[nodeID] definerID
  from 
    [tblNode] n,
    [tblNode] p
  where
    n.[parentID] = p.[nodeID] 
    and n.[nodeType] = 0
GO
create view [dbo].[vwScope_EffectiveNode_ExplicitPrincipal_p]
as
  select
    n.[nodeID]
   ,p.[prinID]
   ,p.[prinUri]
   ,scope.[scopeIsDenied] isDenied
  from
    [tblNode] n
    inner join [vwScope_ScopeDefiners] sd on n.[nodeID] = sd.[nodeID]
    inner join [tblScopedPrincipal] scope on sd.[definerID] = scope.[scopeNodeID]
    inner join [tblPrincipal] p on scope.[scopePrinID] = p.prinID
                                   and p.[prinDisabled] = 0
GO
create procedure [dbo].[procInsertScopedByUri_p]
  (
   @nodeDbId int
  ,@scopeEntries xml
  ,@updater int
  )
as 
  begin
    if @nodeDbId is null 
      begin
        raiserror (50100, 16, 1, '@nodeDbId')
        return -1
      end
    if @updater is null 
      begin
        raiserror (50100, 16, 1, '@updater')
        return -1
      end
    if @scopeEntries is null 
      begin
        raiserror (50100, 16, 1, '@scopeEntries')
        return -1
      end
		
    declare @csv nvarchar(max)
    declare @newScope table
      (
       prinID int
      ,prinUri nvarchar(255) collate Latin1_General_CI_AS 
      ,denied bit
      )
    insert into
      @newScope
      select
        prinID
       ,scope.[key]
       ,scope.[value]
      from
        fnParseXmlStringForKeyValuePairs(@scopeEntries) scope
        left outer join tblPrincipal p on scope.[key] = p.prinUri collate Latin1_General_CI_AS
    if exists ( select
                  *
                from
                  @newScope
                where
                  [prinID] is null ) 
      begin
        set @csv = ''
        select
          @csv = @csv + [prinUri] + ', '
        from
          @newScope
        where
          [prinID] is null								
        set @csv = left(@csv, len(@csv) - 2)
        raiserror (50200, 16, 1, @csv)
        return -1
      end
    if exists ( select
                  *
                from
                  @newScope
                  inner join tblPrincipal on [@newScope].[prinID] = [tblPrincipal].[prinID]
                where
                  prinDisabled <> 0 ) 
      begin
        set @csv = ''
        select
          @csv = @csv + [@newScope].[prinUri] + ', '
        from
          @newScope
          inner join tblPrincipal on [@newScope].[prinID] = [tblPrincipal].[prinID]
        where
          prinDisabled <> 0 								
        set @csv = left(@csv, len(@csv) - 2)
        raiserror (50202, 16, 1, @csv)
        return -1
      end
    declare
      @Tc int
     ,@Sp varchar(10)
    select
      @Tc = @@trancount
     ,@Sp = @@procid
    if (@Tc = 0) 
      begin
        set transaction isolation level read committed
        begin transaction @Sp
      end
    else 
      begin
        save transaction @Sp
      end
    begin try
      insert into
        [tblScopedPrincipal]
        (
         scopeNodeID
        ,scopePrinID
        ,scopeUpdatedBy
        ,scopeIsDenied        
        )
        select
          @nodeDbId
         ,prinID
         ,@updater
         ,denied
        from
          @newScope
      if (@Tc = 0) 
        commit transaction @Sp
    end try
    begin catch
      exec RethrowError
      if (xact_state() <> 0) 
        begin
          rollback transaction @Sp
          return -1
        end
    end catch
  end
go
create procedure [dbo].[procSetScope]
  (
   @nodeDbId int
  ,@prinUris ntext
  ,@updater int
  )
as 
  declare
    @Tc int
   ,@Sp varchar(10)
   ,@step tinyint
  select
    @Tc = @@trancount
   ,@Sp = @@procid
  if (@Tc = 0) 
    begin
      set transaction isolation level read committed
      begin transaction @Sp
    end
  else 
    begin
      save transaction @Sp
    end
  begin try
    set @step = 1
    delete from
      tblScopedPrincipal
    where
      scopeNodeID = @nodeDbId
    set @step = 2
    exec procInsertScopedByUri_p @nodeDbId, @prinUris, @updater
    if (@Tc = 0) 
    begin
      commit transaction @Sp
      return 0
    end
  end try
  begin catch
    exec RethrowError
    if (xact_state() <> 0) 
      begin
        rollback transaction @Sp
        return -1
      end
  end catch
go
create procedure [dbo].[procPurgeScopeAndRolesNoLongerInScope]
as 
  set nocount on
  declare @prinsToDescope table
    (
     affectedNodeID int
    ,prinID int
    )
  declare @prinsToDerole table
    (
     affectedNodeID int
    ,prinID int
    ,roleID int
    )
  begin transaction
  begin try
    insert into
      @prinsToDescope
      select
        explicitScope.[scopeNodeID]
       ,prin.prinID
      from
        [tblScopedPrincipal] explicitScope
        inner join [tblPrincipal] prin on explicitScope.[scopePrinID] = prin.prinID
      where
        prin.prinDisabled <> 0
    delete from
      [tblScopedPrincipal]
    from
      [tblScopedPrincipal]
      inner join @prinsToDescope on [scopeNodeID] = [affectedNodeID]
                                    and [scopePrinID] = [prinID]
    insert into
      @prinsToDerole
      select distinct
        explicitRole.[prinRoleNodeID]
       ,prin.prinID
       ,explicitRole.[prinRoleTypeID]
      from
        [tblPrincipalRole] explicitRole
        inner join tblPrincipal prin on explicitRole.[prinRolePrinID] = prin.prinID
      where
        prin.prinDisabled <> 0
    insert into
      @prinsToDerole
      select distinct
        explicitRole.[prinRoleNodeID]
       ,explicitRole.[prinRolePrinID]
       ,explicitRole.[prinRoleTypeID]
      from
        [tblPrincipalRole] explicitRole
        inner join [tblNode] node on explicitRole.[prinRoleNodeID] = node.[nodeID]
        inner join [tblPrincipalAffiliations] a on explicitRole.[prinRolePrinID] = a.[principalID]
        left outer join 
          (select * from [vwScope_ScopeDefiners] sd
             inner join [tblScopedPrincipal] sc on sd.[definerID] = sc.scopeNodeID )         
            inheritedScope on a.[affiliationID] = inheritedScope.[scopePrinID] 
                           and node.[nodeID] = inheritedScope.[nodeID] 
      group by
        explicitRole.[prinRoleNodeID]
       ,explicitRole.[prinRolePrinID]
       ,explicitRole.[prinRoleTypeID]
       ,inheritedScope.[scopeIsDenied]
      having
        (max(inheritedScope.scopeNodeID) is null and inheritedScope.scopeIsDenied is not null)
        or inheritedScope.scopeIsDenied = 1
    delete from
      tblPrincipalRole
    from
      [tblPrincipalRole]
      inner join @prinsToDerole on [prinRoleNodeID] = [affectedNodeID]
                                   and [prinRolePrinID] = [prinID]
    declare @now datetime
    set @now = getutcdate()
    update 
      tblNode 
    set 
      purgedOn = @now
    where
      nodeID in (
          select distinct 
              [affectedNodeID]
          from 
              @prinsToDerole
          union
          select distinct
              sp.[affectedNodeID]
          from
              (select distinct
                  [affectedNodeID]
               from 
                  @prinsToDescope a
                  inner join [tblNode] childChannels on a.[affectedNodeID] = childChannels.[parentID]
              ) sp
          )
    commit transaction
  end try
  begin catch
    rollback transaction
    exec RethrowError
    return -1
  end catch
GO
create procedure [dbo].[procGetPurgedNodes]
  (
   @parm_timestamp datetime
  )
as 
  exec procGetLastPurgeNodesTime
  select 
	[nodeID]
  from 
	[tblNode] 
  where 
	(@parm_timestamp is not null and [purgedOn] > @parm_timestamp)
	or (@parm_timestamp is null and [purgedOn] is not null)
go
create procedure [dbo].[procGetLastPurgeNodesTime]
as 
  select 
	max(purgedOn) as maxPurgedOn
  from 
	tblNode
go
create view [dbo].[vwInviteChannels_p]
AS
SELECT     
    n.nodeID
FROM         
    tblNode n 
    INNER JOIN tblNode AS p ON p.nodeID = n.parentID 
WHERE
    n.nodeType = 0 and
    p.nodeType = 1 and
    n.visibility != 6 and  -- open rooms are not invite rooms
    p.invite = 1 and
    n.disabled = 0 and -- do not want to include disabled rooms
    (n.invite is null or n.invite = 1) 
GO
create procedure [dbo].[procGetRolesForNode_p]
  @nodeID int
 ,@roleID int = null
as 
  select
    n.[nodeID] nodeID
   ,roles.[prinRoleTypeID] roleID
   ,p.[prinID]
   ,p.[prinUri]
  from
    [tblNode] n
    inner join [tblPrincipalRole] roles on n.[nodeID] = roles.[prinRoleNodeID]
                                                     and (@roleID is null or roles.[prinRoleTypeID] = @roleID)
            inner join [tblPrincipal] p on roles.[prinRolePrinID] = p.[prinID]
                                               and p.[prinDisabled] = 0 
  where 
    n.[nodeID] = @nodeID
GO
create procedure [dbo].[procGetRolesForNodes_p]
  @xml xml
  ,@roleID int = null
as 
  declare @nodeIDs table ([id] int)
  insert into
    @nodeIDs
    select
      [entry]
    from
      fnParseDelimitedStringForInt(@xml)
  set transaction isolation level read committed
  select
    n.[nodeID] nodeID
   ,roles.[prinRoleTypeID] roleID
   ,p.[prinID]
   ,p.[prinUri]
  from
    [tblNode] n
    inner join @nodeIDs np on n.[nodeID] = np.[id]
    inner join [tblPrincipalRole] roles on n.[nodeID] = roles.[prinRoleNodeID]
                                                       and (@roleID is null or roles.[prinRoleTypeID] = @roleID)
    inner join [tblPrincipal] p on roles.[prinRolePrinID] = p.[prinID]
GO
create procedure [dbo].[procGetRoleLists] @roleID int, @xml xml
as 
  exec procGetRolesForNodes_p @xml, @roleID
go
create procedure [dbo].[procPurgeRolesNoLongerInScope] @alteredNodeID int
as 
  declare @prinsToDerole table
    (
     affectedNodeID int
    ,prinID int
    )
  insert into
    @prinsToDerole
    select
      [current].*
    from
      (
       select distinct
        r.[prinRoleNodeID] nodeID
       ,r.[prinRolePrinID] prinID
       from
        [tblPrincipalRole] r
       where
        r.[prinRoleNodeID] = @alteredNodeID
       union all
       select distinct
        r.[prinRoleNodeID] nodeID
       ,r.[prinRolePrinID] prinID
       from
        [tblPrincipalRole] r
        inner join [tblNode] n on r.[prinRoleNodeID] = n.[nodeID]
       where
        n.[parentID] = @alteredNodeID
      ) [current]
      left outer join (
                       select distinct
                        n.[nodeID] nodeID
                       ,r.[prinRolePrinID] prinID
                       ,s.[isDenied] isDenied
                       from
                        [tblNode] n
                        inner join [tblPrincipalRole] r on n.[nodeID] = r.[prinRoleNodeID]
                        inner join [tblPrincipal] p on r.[prinRolePrinID] = p.[prinID]
                                                                and p.[prinDisabled] = 0
                        inner join [tblPrincipalAffiliations] a on p.[prinID] = a.[principalID]
                        inner join [vwScope_EffectiveNode_ExplicitPrincipal_p] s on s.[prinID] = a.[affiliationID]
                                                                                and s.[nodeID] = n.[nodeID]
                       where
                        n.[nodeID] = @alteredNodeID
                        or n.[parentID] = @alteredNodeID
                      ) [keepers] on [current].[nodeID] = [keepers].[nodeID]
                                     and [current].[prinID] = [keepers].[prinID]
    where
      keepers.nodeID is null or keepers.isDenied = 1
  delete from
    tblPrincipalRole
  from
    [tblPrincipalRole]
    inner join @prinsToDerole on [prinRoleNodeID] = [affectedNodeID]
                                 and [prinRolePrinID] = [prinID]
  if @@error <> 0 
    delete from
      @prinsToDerole
  select distinct
    affectedNodeID
  from
    @prinsToDerole
  group by
    affectedNodeID
go
create procedure [dbo].[procPurgeVoicedRolesNoLongerInMemberScope] @alteredNodeID int
as 
  declare @voicedToDerole table
    (
    prinID int
    )
  insert into
    @voicedToDerole
    select
      [current].prinID
    from
      (
       select
       r.[prinRolePrinID] prinID
       from
        [tblPrincipalRole] r
       where
        r.[prinRoleNodeID] = @alteredNodeID
        and r.[prinRoleTypeID] = 5
      ) [current]
      left outer join (
                       select distinct
                        a.[principalID] prinID
                       from
                        [tblNode] n
                        inner join [tblPrincipalRole] r on n.[nodeID] = r.[prinRoleNodeID]
                        inner join [tblPrincipalAffiliations] a on r.[prinRolePrinID] = a.[affiliationID]
                       where
                        n.[nodeID] = @alteredNodeID
                        and r.[prinRoleTypeID] = 1
                      ) [keepers] on [current].[prinID] = [keepers].[prinID]
    where
      keepers.prinID is null
  delete from
    tblPrincipalRole
  from
    [tblPrincipalRole]
    inner join @voicedToDerole on [prinRoleNodeID] = @alteredNodeID
                                 and [prinRolePrinID] = [prinID]
                                 and [prinRoleTypeID] = 5
  if @@error <> 0 
    delete from
      @voicedToDerole
  select prinUri 
  from
    tblPrincipal p
    inner join @voicedToDerole r on p.[prinID] = r.[prinID]
GO
create procedure [dbo].[procAddToRole]
  @nodeDbId int
 ,@roleID int
 ,@updatedBy int
 ,@uriList xml
 ,@checkPrins bit = 1
as 
  begin
    if @nodeDbId is null 
      begin
        raiserror (50100, 16, 1, '@nodeDbId')
        return -1
      end
    if @roleID is null 
      begin
        raiserror (50100, 16, 1, '@roleID')
        return -1
      end
    if @updatedBy is null 
      begin
        raiserror (50100, 16, 1, '@updatedBy')
        return -1
      end
    if @uriList is null 
      begin
        raiserror (50100, 16, 1, '@uriList')
        return -1
      end
    set transaction isolation level read committed
    declare @prinsToAdd table
      (
       [uri] nvarchar(256) collate Latin1_General_CI_AS 
      ,[id] int
      )
    insert into @prinsToAdd ([uri], [id])
      select u.[entry], p.[prinID]
      from fnParseDelimitedStringForString(@uriList) u
           inner join [tblPrincipal] p on u.[entry] = p.[prinUri] collate Latin1_General_CI_AS
    declare @errMsgs table (
        [errCode] int,
        [uris] nvarchar(max) collate Latin1_General_CI_AS
    )
    if (@checkPrins = 1)
    begin
        insert into @errMsgs
            exec [dbo].[procCheckPrins]
                    @nodeDbId,
                    @roleID,
                    @uriList
    end
    if not exists (select * from @errMsgs)
        begin
            insert into
              [tblPrincipalRole]
              (
               prinRoleNodeID
              ,prinRoleTypeID
              ,prinRolePrinID
              ,prinRoleUpdatedBy            
              )
              select
                @nodeDbId
               ,@roleID
               ,p.[prinID]
               ,@updatedBy
              from
                @prinsToAdd u
                inner join [tblPrincipal] p on u.[uri] = p.prinUri            
        end
    select * from @errMsgs
  end
go
create procedure [dbo].[procRemoveFromRole]
  @nodeDbId int
 ,@roleID int
 ,@updatedBy int
 ,@uriList xml
as 
  begin
    set transaction isolation level read committed
    declare @prinsToRemove table
      (
       [uri] nvarchar(256) collate Latin1_General_CI_AS 
      ,[id] int
      )
    insert into
      @prinsToRemove ([uri], [id])
      select
        u.[entry]
       ,p.[prinID]
      from
        fnParseDelimitedStringForString(@uriList) u
        inner join [tblPrincipal] p on u.[entry] = p.[prinUri] collate Latin1_General_CI_AS
    delete from
      [tblPrincipalRole]
    where
      prinRoleNodeID = @nodeDbId
      and prinRoleTypeID = @roleID
      and [prinRolePrinID] in (select
                                [id]
                               from
                                @prinsToRemove)
  end
go
create procedure [dbo].[procReplaceRole]
@nodeDbId int,
@roleID int,
@updatedBy int,
@uriReplaceList xml
as
    declare @errMsgs table (
        [errCode] int,
        [uris] nvarchar(max) collate Latin1_General_CI_AS
    )
    begin transaction
        delete from
            [tblPrincipalRole]
        where
            prinRoleNodeID = @nodeDbId
            and prinRoleTypeID = @roleID
        if (@@error <> 0)
            begin
                rollback
                return -1
            end
    insert into @errMsgs
        exec [dbo].[procCheckPrins]
            @nodeDbId,
            @roleID,
            @uriReplaceList
    if exists (select * from @errMsgs)
        begin
            rollback
            return -1
        end
    else
        begin
            begin try
                exec [dbo].[procAddToRole]
                    @nodeDbId,
                    @roleID,
                    @updatedBy,
                    @uriReplaceList,
                    0 
            end try
            begin catch
                exec RethrowError
                if (@@error <> 0)
                    begin
                        rollback
                        return -1
                    end
            end catch
            commit transaction
        end
    select * from @errMsgs
go
create procedure [dbo].[procCheckPrins]
@nodeDbId int,
@roleID int,
@uriList xml
as
    if @nodeDbId is null 
      begin
        raiserror (50100, 16, 1, '@nodeDbId')
        return -1
      end
    if @roleID is null 
      begin
        raiserror (50100, 16, 1, '@roleID')
        return -1
      end
    if @uriList is null 
      begin
        raiserror (50100, 16, 1, '@uriList')
        return -1
      end
    set transaction isolation level read committed
    declare
      @errMsg nvarchar(max)
    declare @errMsgs table (
        [errCode] int,
        [uris] nvarchar(max) collate Latin1_General_CI_AS
    )
    declare @prinsToAdd table (
        [uri] nvarchar(256) collate Latin1_General_CI_AS,
        [id] int
    )    
    insert into @prinsToAdd ([uri], [id])
      select u.[entry], p.[prinID]
      from fnParseDelimitedStringForString(@uriList) u
           inner join [tblPrincipal] p on u.[entry] = p.[prinUri] collate Latin1_General_CI_AS
    declare @errUris table ([uri] nvarchar(256) collate Latin1_General_CI_AS )
    declare @errs table (
            uri nvarchar(256) collate Latin1_General_CI_AS,
            prinType int,
            adPath nvarchar(384) collate Latin1_General_CI_AS
            )
    insert into @errUris ([uri])
      select p.[uri]
      from [tblPrincipalRole] r
           inner join @prinsToAdd p on p.id = r.[prinRolePrinID]
      where [prinRoleNodeID] = @nodeDbId and
            [prinRoleTypeID] = @roleID
    if exists ( select *
                from @errUris ) 
      begin
        insert into @errs
            select p.prinUri, p.prinTypeID, p.prinADPath
            from @errUris, tblPrincipal p
            where uri = p.prinUri
        select @errMsg = case when (prinType = 3 or prinType = 8 or prinType = 9 or prinType = 10) then (adPath + ', ')
                              else (uri + ', ') end
        from @errs
        set @errMsg = left(@errMsg, len(@errMsg) - 1)
        insert into @errMsgs
            values(50320, @errMsg)
        delete from @errUris
        delete from @errs
        set @errMsg = ''
      end
    insert into @errUris ([uri])
      select p.[uri]
      from @prinsToAdd p
            left outer join (select p.[prinID], s.[isDenied]
                             from @prinsToAdd adds --@prinsToAdd is not necessary for data accuracy.  it's here as a filter to reduce the number of principals the db will process
                                  inner join tblPrincipal p on adds.[id] = p.[prinID]
                                                               and p.[prinDisabled] = 0
                                  inner join tblPrincipalAffiliations a on p.prinID = a.principalID
                                  inner join [vwScope_EffectiveNode_ExplicitPrincipal_p] s on a.[affiliationID] = s.[prinID]
                             where s.[nodeID] = @nodeDbId) scoped on p.[id] = scoped.[prinID]
      where scoped.[prinID] is null or scoped.[isDenied] = 1
    if exists (select *
               from @errUris) 
      begin
        insert into @errs
            select p.prinUri, p.prinTypeID, p.prinADPath
            from @errUris, tblPrincipal p
            where uri = p.prinUri
        select @errMsg = case when (prinType = 3 or prinType = 8 or prinType = 9 or prinType = 10) then (isnull(@errMsg, '') + adPath + ', ')
                              else (isnull(@errMsg, '') + uri + ', ') end
        from @errs
        set @errMsg = left(@errMsg, len(@errMsg) - 1)
        insert into @errMsgs
            values(50321, @errMsg)
        delete from @errUris
        delete from @errs
        set @errMsg = ''
      end
    declare @visible int
    select @visible = [visibility] from tblNode where tblNode.nodeID = @nodeDbId
    if (@roleID = 5 and @visible != 6)
        insert into @errUris ([uri])
          select distinct pAdd.[uri]
          from @prinsToAdd pAdd
          where pAdd.id not in (select distinct a.principalID
                                from [tblPrincipalAffiliations] a 
                                        inner join [tblPrincipalRole] p on a.affiliationID = p.prinRolePrinID
                                where p.prinRoleNodeID = @nodeDbId and p.prinRoleTypeID = 1)
    if exists ( select *
                from @errUris ) 
        begin
            insert into @errs
                select p.prinUri, p.prinTypeID, p.prinADPath
                from @errUris, tblPrincipal p
                where uri = p.prinUri
            select @errMsg = case when (prinType = 3 or prinType = 8 or prinType = 9 or prinType = 10) then (isnull(@errMsg, '') + adPath + ', ')
                                  else (isnull(@errMsg, '') + uri + ', ') end
            from @errs
            set @errMsg = left(@errMsg, len(@errMsg) - 1)
            insert into @errMsgs
                values(50324, @errMsg)
            delete from @errUris
            set @errMsg = ''
        end
    select *
    from @errMsgs
    if exists (select * from @errMsgs)
        return -1
    return 0
go
create procedure [dbo].[procScopePrins_p]
@nodeDbId int,
@roleID int,
@uriList xml
as
    if @nodeDbId is null 
      begin
        raiserror (50100, 16, 1, '@nodeDbId')
        return -1
      end
    if @uriList is null 
      begin
        raiserror (50100, 16, 1, '@uriList')
        return -1
      end
    set transaction isolation level read committed
    declare @prinsToAdd table (
        [uri] nvarchar(256) collate Latin1_General_CI_AS,
        [id] int
    )
    insert into @prinsToAdd ([uri], [id])
      select u.[entry], p.[prinID]
      from fnParseDelimitedStringForString(@uriList) u
           inner join [tblPrincipal] p on u.[entry] = p.[prinUri] collate Latin1_General_CI_AS
    delete from @prinsToAdd 
    where [uri] in (
      select p.[uri]
      from @prinsToAdd p
            left outer join (select p.[prinID], s.[isDenied]
                             from @prinsToAdd adds --@prinsToAdd is not necessary for data accuracy.  it's here as a filter to reduce the number of principals the db will process
                                  inner join tblPrincipal p on adds.[id] = p.[prinID]
                                                               and p.[prinDisabled] = 0
                                  inner join tblPrincipalAffiliations a on p.prinID = a.principalID
                                  inner join [vwScope_EffectiveNode_ExplicitPrincipal_p] s on a.[affiliationID] = s.[prinID]
                             where s.[nodeID] = @nodeDbId) scoped on p.[id] = scoped.[prinID]
      where scoped.[prinID] is null or scoped.[isDenied] = 1)   
    if (@roleID = 5)
    begin
        declare @visible int
        select @visible = [visibility] from tblNode where tblNode.nodeID = @nodeDbId
        if (@visible != 6)
             delete from @prinsToAdd
             where id not in (select distinct a.principalID
                                    from [tblPrincipalAffiliations] a 
                                            inner join [tblPrincipalRole] p on a.affiliationID = p.prinRolePrinID
                                    where p.prinRoleNodeID = @nodeDbId and p.prinRoleTypeID = 1)
    end                                
    select uri from @prinsToAdd
go
create procedure [dbo].[procUpdateRoleHelper]
 @parm_dbId int,
 @parm_roleId int,
 @parm_replaceUris xml,
 @parm_addUris xml,
 @parm_removeUris xml,
 @parm_nodeUpdatedBy int
as
    set transaction isolation level read committed
    begin try
        if (@parm_replaceUris is not null)
        begin
            delete from
            [tblPrincipalRole]
            where prinRoleNodeID = @parm_dbId and
                  prinRoleTypeID = @parm_roleId
            if (@@error <> 0)
            begin
                return -1
            end
        end
        if (@parm_removeUris is not null)
        begin
            exec [dbo].[procRemoveFromRole]
                @parm_dbId, @parm_roleId, @parm_nodeUpdatedBy,
                @parm_removeUris
            if (@@error <> 0)
            begin
                return -1
            end
        end
        if (@parm_replaceUris is not null or @parm_addUris is not null)
        begin
            declare @sucVal int = 0
            declare @mgrCheckUris xml = case when @parm_replaceUris is not null then @parm_replaceUris else @parm_addUris end
            exec @sucVal = [dbo].[procCheckPrins]
                @parm_dbId,
                @parm_roleId,
                @mgrCheckUris
            if (@sucVal = -1) -- the pre-flight of the prins checking failed
            begin
                return -1
            end
            declare @mgrAddUris xml = case when @parm_replaceUris is null then @parm_addUris else @parm_replaceUris end
            exec [dbo].[procAddToRole]
                @parm_dbId, @parm_roleId, @parm_nodeUpdatedBy, 
                @mgrAddUris, 0
            if (@@error <> 0)
            begin
                return -1
            end
        end
    end try
    begin catch
        exec RethrowError
        return -1
    end catch
    return 0
go
create procedure [dbo].[procGetExplicitRoleList]
  @nodeID int
 ,@roleID int
as
  exec procGetRolesForNode_p @nodeID, @roleID
GO
create procedure procRecalculateInvites
@parmChannelId int,
@parmPrinId int,
@parmMaxInvitesPerUser int
as
begin
declare @now datetime
set @now = GetUtcDate()
declare
  @true bit
 ,@false bit
select
  @true = 1
 ,@false = 0
declare @allInvites table
    (
    prinID int
    ,nodeID int
    )
begin transaction
    insert into 
        @allInvites (prinID, nodeID)
    select distinct  
        p.prinID, 
        ic.nodeID
    from 
        vwInviteChannels_p ic
        inner join tblPrincipalRole as roles on ic.nodeID = roles.prinRoleNodeID
                                                and roles.prinRoleTypeID = 1
        inner join tblPrincipalAffiliations as pa on roles.prinRolePrinID = pa.affiliationID
        inner join tblPrincipal as p on pa.principalID = p.prinID
                                                and p.prinDisabled = 0
        inner join tblPrincipal as pav on pa.affiliationID = pav.prinID
                                                and pav.prinDisabled = 0
    where
        p.prinTypeID in (select ptypeID from tblPrincipalType where ptypeIsUser = 1) and
        (@parmChannelId = -1 or @parmChannelId = ic.nodeID) and
        (@parmPrinId = -1 or @parmPrinId = p.prinID)
    order by 
        p.prinID, ic.nodeID  
    delete 
        tblPrincipalInvites
    from
        @allInvites a
        right outer join tblPrincipalInvites inv on inv.nodeID = a.nodeID and inv.prinID = a.prinID
    where 
        a.nodeID is null and
        (@parmChannelId = -1 or @parmChannelId = inv.nodeID) and
        (@parmPrinId = -1 or @parmPrinId = inv.prinID)
    insert into 
        tblPrincipalInvites (prinID, nodeID, invID, createdOn)
    select distinct
        newInv.prinID
       ,newInv.nodeID 
       ,Case when linv.lastInviteID is null then RowNumber else linv.lastInviteID + RowNumber end as invID
       ,@now
    from
        (
            select distinct
                ROW_NUMBER() OVER(PARTITION BY a.prinID ORDER BY a.nodeID) AS RowNumber
               ,a.prinID
               ,a.nodeID 
            from
                @allInvites a
                left outer join tblPrincipalInvites inv on inv.nodeID = a.nodeID and inv.prinID = a.prinID
            where 
                inv.nodeID is null
        ) newInv
        left outer join tblLastInviteId linv on linv.prinID = newInv.prinID
        left outer join 
        (
            select 
                prinID, Count(invID) as inviteCount
            from
                tblPrincipalInvites
            group by
                prinID
        ) existing on newInv.prinID = existing.prinID
    where
        (existing.inviteCount is not null and RowNumber + existing.inviteCount <= @parmMaxInvitesPerUser)
        or (existing.inviteCount is null and RowNumber <= @parmMaxInvitesPerUser)
    declare @maxInvIds table
    (
    prinID int
    ,maxInvID int
    )
    insert into 
        @maxInvIds (prinID, maxInvID)
    select 
        prinID, Max(invID) as maxInvID
    from
        tblPrincipalInvites
    where
        (@parmPrinId = -1 or @parmPrinId = prinID)
    group by
        prinID
    update
        tblLastInviteId
    set
        lastInviteID = a.maxInvID
    from
        @maxInvIds a
        inner join tblLastInviteId b on a.prinID = b.prinID
    where
        b.lastInviteID < a.maxInvID
    insert into
        tblLastInviteId (prinID, lastInviteID)
    select 
        a.prinID, a.maxInvID
    from
        @maxInvIds a
        left outer join tblLastInviteId b on a.prinID = b.prinID
    where
        b.prinID is null
if @@ERROR <> 0 
  rollback transaction
else 
  commit transaction
end
GO
create procedure procGetLastInviteTimestamp
as
    select 
        max(createdOn) as maxCreatedOn
    from 
        tblPrincipalInvites
GO
create procedure procGetNewInvites
  (
   @parm_timestamp datetime
  )
as
    exec procGetLastInviteTimestamp
    select 
        distinct prinID 
    from 
        tblPrincipalInvites 
    where
        (@parm_timestamp is not null and [createdOn] > @parm_timestamp)
        or (@parm_timestamp is null and [createdOn] is not null)
GO
create procedure procGetInvites
  (
   @xml xml
   ,@parmMaxInvitesPerRequest int
  )
as 
begin
    declare @map table (
        i int identity
        ,k int
        ,v int
    )
    insert
        @map
    select
        r.value('@k', 'int')
        ,r.value('@v', 'int')
    from 
        @xml.nodes('ROOT/r') item (r)	
select
        req.i - 1 as requestId
        ,req.k as prinID
        ,inv.nodeID
        ,inv.invID
        ,inv.createdOn
    from
        @map req
        left outer join
            (
            select
              i
             ,prinID
             ,nodeID
             ,invID
             ,createdOn
            from
                (
                select
                  ROW_NUMBER() OVER(PARTITION BY a.i ORDER BY b.invID) AS RowNumber
                 ,a.i
                 ,a.k as prinID
                 ,nodeID
                 ,b.invID
                 ,b.createdOn
                from
                  @map a
                  inner join tblPrincipalInvites b on a.k = b.prinID
                where
                  b.invID > a.v
                ) c
                where 
                    RowNumber <= @parmMaxInvitesPerRequest
            ) inv on req.i = inv.i
end
go
create procedure procGetMembershipAssociations
@parmPrinID int,
@parmMax bigint
as
begin
    select distinct top (@parmMax) 
        n.nodeName, 
        n.nodeGuid,
        n.nodeDesc,
        n.behavior
    from 
        tblNode n
        inner join tblPrincipalRole as roles on n.nodeID = roles.prinRoleNodeID
                                                and roles.prinRoleTypeID = 1
        inner join tblPrincipalAffiliations as pa on roles.prinRolePrinID = pa.affiliationID
        inner join tblPrincipal as p on pa.principalID = p.prinID
                                                and p.prinDisabled = 0
        inner join tblPrincipal as pav on pa.affiliationID = pav.prinID
                                                and pav.prinDisabled = 0
    where
        n.nodeType = 0 and
        n.disabled = 0 and
        n.visibility != 6 and
        p.prinID = @parmPrinID
    order by 
        n.nodeName  
end
GO
create procedure procGetManagershipAssociations
@parmPrinID int,
@parmMax bigint
as
begin
    select distinct top (@parmMax) 
        n.nodeName, 
        n.nodeGuid,
        n.nodeDesc,
        n.behavior
    from 
        tblNode n
        inner join tblPrincipalRole as roles on n.nodeID = roles.prinRoleNodeID
                                                and roles.prinRoleTypeID = 2
        inner join tblPrincipalAffiliations as pa on roles.prinRolePrinID = pa.affiliationID
        inner join tblPrincipal as p on pa.principalID = p.prinID
                                                and p.prinDisabled = 0
        inner join tblPrincipal as pav on pa.affiliationID = pav.prinID
                                                and pav.prinDisabled = 0
    where
        n.nodeType = 0 and
        n.disabled = 0 and
        p.prinID = @parmPrinID
    order by 
        n.nodeName  
end
GO
create procedure [dbo].[getContextualBackChat]
  @parmChannelId int            --channel to search on
 ,@parmLimit int            --select top @parmLimit
 ,@parmMessageId bigint --id of the message to search for.  if 0, then no message
 ,@parmPre int = 0          --number of messages to retrieve prior to @parmMessageId
as 
  set nocount on
  if @parmPre != 0
    and @parmMessageId != 0 
    set @parmMessageId = @parmMessageId - @parmPre
  set @parmLimit = @parmLimit + 1
  select
    chatId
   ,chatDate
   ,prinUri
   ,prinDisplayName
   ,channelId
   ,isAlert
   ,[content]
   ,[rtf]
  from
    (
     select top (@parmLimit)
      chatId
     ,chatDate
     ,channelId
     ,userId
     ,isAlert
     ,[content]
     ,[rtf]
     from
      tblChat
     where
      channelId = @parmChannelId
      and chatId >= @parmMessageId
     order by
      chatId desc
    ) chatSubset
    inner join tblPrincipal on userId = prinID
  order by
    chatId desc
go
create procedure [dbo].[getContextualBackChatWithJump]
  @parmChannelId int            --channel to search on
 ,@parmLimit int            --select top Limit
 ,@parmMessageId bigint --id of the message to search for.  if 0, then no message
 ,@parmPre int          --number of messages to retrieve prior to @parmMessageId
as 
  set nocount on
  if @parmPre != 0
    and @parmMessageId != 0 
    set @parmMessageId = @parmMessageId - @parmPre
  select top (@parmLimit)
    chatId
   ,chatDate
   ,prinUri
   ,prinDisplayName
   ,channelId
   ,isAlert
   ,[content]
   ,[rtf]
  from
    tblPrincipal
    inner join tblChat on userId = prinID
                          and channelId = @parmChannelId
                          and chatId >= @parmMessageId
  order by
    chatId desc
go
create procedure [dbo].[procInsertChatMessage_p]
  (
   @parm_ChannelId int
  ,@parm_ChatId bigint
  ,@parm_ChatDate bigint
  ,@parm_UserID int
  ,@parm_Alert bit = 0
  ,@parm_Content nvarchar(max)
  ,@parm_Rtf varchar(max)
  )
as 
  begin
    insert into
      [tblChat]
      (
       [channelId]
      ,[chatId]
      ,[chatDate]
      ,[userId]
      ,[isAlert]
      ,[content]
      ,[rtf]
      )
    values
      (
       @parm_ChannelId
      ,@parm_ChatId
      ,@parm_ChatDate
      ,@parm_UserID
      ,@parm_Alert
      ,@parm_Content
      ,@parm_Rtf
      )
  end
go
create procedure [dbo].[procInsertChatMessage]
  (
   @parm_ChannelId int
  ,@parm_UserID int
  ,@parm_Alert bit = 0
  ,@parm_Content nvarchar(max)
  ,@parm_Rtf varchar(max)
  ,@parm_ChatDate bigint = 0 output
  ,@parm_ChatId bigint = 0 output
  )
as 
  set nocount on
  declare
    @Tc int
   ,@Sp varchar(10)
  select
    @Tc = @@trancount
   ,@Sp = @@procid
  if (@Tc = 0) 
    begin
      set transaction isolation level serializable
      begin transaction @Sp
    end
  else 
    begin
      save transaction @Sp
    end
  begin try
    update
      tblLastChatId
    set
      @parm_ChatId = [lastChatID] + 1
     ,[lastChatID] = [lastChatID] + 1
    from
      [tblLastChatId]
    where
      [nodeID] = @parm_ChannelId
    set @parm_ChatDate = dbo.fnDateToTicks(getutcdate())
    exec procInsertChatMessage_p @parm_ChatId = @parm_ChatId, --bigint
      @parm_ChannelId = @parm_ChannelId, --  int
      @parm_UserID = @parm_UserID, --  int
      @parm_ChatDate = @parm_ChatDate, --  bigint
      @parm_Alert = @parm_Alert, --  bit
      @parm_Content = @parm_Content, --  nvarchar(max)
      @parm_Rtf = @parm_Rtf --  varchar(max)
    if (@Tc = 0) 
      commit transaction @Sp
  end try
  begin catch
    exec RethrowError
    if (xact_state() <> 0) 
      begin
        rollback transaction @Sp
        return -1
      end
  end catch
go
create procedure [dbo].[procDeleteMessages]
  (
   @channelDbId int
  ,@chatDbIds xml
  ,@physicallyDelete bit
  ,@text nvarchar(max)
  ,@rtf nvarchar(max)
  )
as
  if @physicallyDelete = 1
    delete        
      tblChat
    where
      [channelId] = @channelDbId and
      [chatId] in (select ids.entry from fnParseDelimitedStringForInt(@chatDbIds) ids)
  else
    update
      tblChat
    set
      [content] = @text
     ,[rtf] = @rtf
    from       
      tblChat
      inner join fnParseDelimitedStringForInt(@chatDbIds) ids
           on [tblChat].[chatId] = ids.entry
    where
      [channelId] = @channelDbId
go
create procedure [dbo].[procInsertFileToken]
  @tokenId nvarchar(50)
 ,@prinUri nvarchar(256)
 ,@channelId uniqueidentifier
 ,@expiresOn datetime
 ,@pinnedForCompliance bit
as 
  set nocount on
  insert into
    [tblFileToken]
    (
     [fileToken]
    ,[fileTokenUserID]
    ,[fileTokenChannelID]
    ,[fileTokenExpireDate]
    ,[fileTokenCompliancePinned]
    )
    select
      @tokenId
     ,[prinID]
     ,@channelId
     ,@expiresOn
     ,@pinnedForCompliance
    from
      [tblPrincipal]
    where
      [prinUri] = @prinUri
GO
create procedure [dbo].[procPurgeFileTokens]
as 
  set nocount on
  delete from
    [tblFileToken]
  where
    [fileTokenExpireDate] <= getutcdate()
    and ([fileTokenComplianceTime] is null
      or
      [fileTokenCompliancePinned] = 0)
GO
create procedure [dbo].[procExpireFileToken] @tokenId nvarchar(50)
as 
  set nocount on
  update
    [tblFileToken]
  set
    [fileTokenExpireDate] = getutcdate()
  where
    [fileToken] = @tokenId
GO
create procedure [dbo].[procAddComplianceDataToFileToken] 
  @tokenId nvarchar(50)
 ,@fileUrl nvarchar(256)
 ,@thumbnailUrl nvarchar(256)
 ,@timeOfAction datetime2
 ,@isUpload bit
as 
  set nocount on
  update
    [tblFileToken]
  set
    [fileTokenComplianceFileUrl] = @fileUrl
   ,[fileTokenComplianceThumbnailUrl] = @thumbnailUrl
   ,[fileTokenComplianceTime] = @timeOfAction
   ,[fileTokenComplianceIsUpload] = @isUpload
  where
    [fileToken] = @tokenId
GO
create procedure [dbo].[procGetFileToken] @tokenId nvarchar(50)
as 
  set nocount on
  select
    [fileToken]
   ,[prinUri]
   ,[fileTokenChannelID]
   ,[fileTokenExpireDate]
  from
    [tblFileToken]
    inner join [tblPrincipal] on [fileTokenUserID] = [prinID]
  where
    [fileToken] = @tokenId
go
create procedure [dbo].[procGetFileComplianceInfo]
  @tokenList xml
as
  select 
    tl.entry
   ,case when t.fileToken is null then 1
         else 0
    end fileTokenNotFound
   ,t.fileTokenComplianceFileUrl
   ,t.fileTokenComplianceThumbnailUrl
   ,t.fileTokenComplianceTime
   ,t.fileTokenComplianceIsUpload
  from 
    [tblFileToken] t
    right outer join [dbo].[fnParseDelimitedStringForString](@tokenList) tl
    on tl.entry = t.fileToken
go
create procedure [dbo].[procUnpinFileTokens]
  @tokenList xml
as
  update
    [tblFileToken]
  set 
    [fileTokenCompliancePinned] = 0
  where
    [fileToken] in
      (select entry from [dbo].[fnParseDelimitedStringForString](@tokenList))
go
create procedure [dbo].[procProcessADUpdates]
as 
  begin
    set transaction isolation level read committed
    declare
      @true bit
     ,@false bit
    select
      @true = 1
     ,@false = 0
	
	
	-- remove all non provisioned Users and UserGroups with no DG member changes
    delete from
      tblADUpdates
    where
      prinMembersChanged = @false
      and prinGuid not in (select
                            prinGuid
                           from
                            tblPrincipal)
    begin transaction
					
		--Which principals are dirty and to what extent?
		--[*attribute-dirty*] All provisioned principals with no member changes
		
    select distinct
      p.prinID as prinID
     ,@false as prinAffiliationsDirty
     ,@true as prinAttributesDirty
     ,ad.prinDeleted as prinDeleted
    into #tblPrincipalMeta1
    from
      tblADUpdates ad
      join tblPrincipal p on ad.prinGuid = p.prinGuid
    where
      (
       ad.prinMembersChanged = @false
       or ad.prinAttributesChanged = @true
      )
      and p.prinID not in (select
                            prinID
                           from
                            tblPrincipalMeta)
			
    update
      tblPrincipalMeta
    set
      prinAttributesDirty = @true
     ,prinDeleted = ad.prinDeleted | pm.prinDeleted
     ,tryCount = 0
     ,nextTry = null
    from
      tblPrincipalMeta pm
      join tblPrincipal p on pm.prinID = p.prinID
      join tblADUpdates ad on ad.prinGuid = p.prinGuid
    where
      ad.prinMembersChanged = @false
      or ad.prinAttributesChanged = @true
		
		--[*affiliation-dirty*] All provisioned member changes (recognized members that are added or removed from any DG) and provisioned principals affiliated with them
		-- Notes: non-provisioned directory groups will only get provisioned as a result of a principal affiliation refresh.
		-- list of dirty principal IDs based on member changes
		
		--mark known principals as dirty
    select distinct
      prinID
     ,@true as prinAffiliationsDirty
     ,@false as prinAttributesDirty
     ,@false as prinDeleted
    into #tblPrincipalMeta2
    from
      tblPrincipalMemberDifference n
      inner join tblPrincipal p on n.memberADPath = p.prinADPath
    where
      prinID not in (select
                      prinID
                     from
                      tblPrincipalMeta)
		
    update
      tblPrincipalMeta
    set
      prinAffiliationsDirty = @true
     ,tryCount = 0
     ,nextTry = null
    from
      tblPrincipalMeta pm
    where
      pm.prinID in (select
                      prinID
                    from
                      tblPrincipalMemberDifference n
                      inner join tblPrincipal p on n.memberADPath = p.prinADPath)
			
		--mark known principals affiliated with known principals as dirty
    select distinct
      pa.principalID as prinID
     ,@true as prinAffiliationsDirty
     ,@false as prinAttributesDirty
     ,@false as prinDeleted
    into #tblPrincipalMeta3
    from
      tblPrincipalAffiliations pa
    where
      pa.[index] <> -1 -- exclude self-affiliation
      and pa.affiliationID in (select
                                prinID
                               from
                                tblPrincipalMemberDifference n
                                inner join tblPrincipal p on n.memberADPath = p.prinADPath)
      and pa.principalID not in (select
                                  prinID
                                 from
                                  tblPrincipalMeta)
			
    update
      tblPrincipalMeta
    set
      prinAffiliationsDirty = @true
     ,tryCount = 0
     ,nextTry = null
    from
      tblPrincipalMeta pm
      join tblPrincipalAffiliations pa on pm.prinID = pa.principalID
    where
      pa.[index] <> -1 -- exclude self-affiliation
      and pa.affiliationID in (select
                                prinID
                               from
                                tblPrincipalMemberDifference n
                                inner join tblPrincipal p on n.memberADPath = p.prinADPath)
	--mark principals affiliated with a deleted principal as dirty	
	
    select distinct
      pa.principalID as prinID
     ,@true as prinAffiliationsDirty
     ,@false as prinAttributesDirty
     ,@false as prinDeleted
    into #tblPrincipalMeta4
    from
      tblPrincipalAffiliations pa
    where
      pa.[index] <> -1 -- exclude self-affiliation
      and pa.affiliationID in (select
                                p.prinID
                               from
                                tblADUpdates ad
                                join tblPrincipal p on ad.prinGuid = p.prinGuid
                               where
                                ad.prinDeleted = @true)
		
		--insert all new distinct DirtyPrincipals. 
		--Note since we are reading only read commited records we can't depend on state changes to tblPrincipalMeta inside this transaction
    insert into #tblPrincipalMeta1
      select
        *
      from #tblPrincipalMeta2
      where
        prinID not in (select
                        prinID
                       from #tblPrincipalMeta1)
    update #tblPrincipalMeta1
    set
      prinAffiliationsDirty = pm1.prinAffiliationsDirty | pm2.prinAffiliationsDirty
     ,prinAttributesDirty = pm1.prinAttributesDirty | pm2.prinAttributesDirty
     ,prinDeleted = pm1.prinDeleted | pm2.prinDeleted
    from #tblPrincipalMeta2 pm2
      join #tblPrincipalMeta1 pm1 on pm2.prinID = pm1.prinID
    insert into #tblPrincipalMeta1
      select
        *
      from #tblPrincipalMeta3
      where
        prinID not in (select
                        prinID
                       from #tblPrincipalMeta1)
    update #tblPrincipalMeta1
    set
      prinAffiliationsDirty = pm1.prinAffiliationsDirty | pm3.prinAffiliationsDirty
     ,prinAttributesDirty = pm1.prinAttributesDirty | pm3.prinAttributesDirty
     ,prinDeleted = pm1.prinDeleted | pm3.prinDeleted
    from #tblPrincipalMeta3 pm3
      join #tblPrincipalMeta1 pm1 on pm3.prinID = pm1.prinID
    insert into #tblPrincipalMeta1
      select
        *
      from #tblPrincipalMeta4
      where
        prinID not in (select
                        prinID
                       from #tblPrincipalMeta1)
    update #tblPrincipalMeta1
    set
      prinAffiliationsDirty = pm1.prinAffiliationsDirty | pm4.prinAffiliationsDirty
     ,prinAttributesDirty = pm1.prinAttributesDirty | pm4.prinAttributesDirty
     ,prinDeleted = pm1.prinDeleted | pm4.prinDeleted
    from #tblPrincipalMeta4 pm4
      join #tblPrincipalMeta1 pm1 on pm4.prinID = pm1.prinID
		--finally insert the aggregated contents into tblPrincipalMeta
    insert into
      tblPrincipalMeta
      (
       prinID
      ,prinAffiliationsDirty
      ,prinAttributesDirty
      ,prinDeleted
      )
      select
        prinID
       ,prinAffiliationsDirty
       ,prinAttributesDirty
       ,prinDeleted
      from #tblPrincipalMeta1
      where
        prinID not in (select
                        prinID
                       from
                        tblPrincipalMeta)
    update
      tblPrincipalMeta
    set
      prinAffiliationsDirty = pm1.prinAffiliationsDirty | pm.prinAffiliationsDirty
     ,prinAttributesDirty = pm1.prinAttributesDirty | pm.prinAttributesDirty
     ,prinDeleted = pm1.prinDeleted | pm.prinDeleted
     ,tryCount = 0
     ,nextTry = null
    from #tblPrincipalMeta1 pm1
      join tblPrincipalMeta pm on pm.prinID = pm1.prinID
		
		-- drop temp tables
    drop table #tblPrincipalMeta1
    drop table #tblPrincipalMeta2
    drop table #tblPrincipalMeta3
		
		--Update Database State:
		--Update tblPrincipalMembers
		
    delete from
      tblPrincipalMembers
    from
      tblPrincipalMembers pm
      join tblPrincipal p on p.prinID = pm.prinID
      join tblPrincipalMemberDifference npm on p.prinGuid = npm.prinGuid
                                               and pm.memberADPath = npm.memberADPath
    where
      npm.memberRemoved = @true
		
    select distinct 
      added.prinID, added.memberADPath
      into #temptblPrincipalMembers
    from 
      (
        select distinct    
            p.prinID, npm.memberADPath
        from
            tblPrincipalMemberDifference npm
            join tblPrincipal p on p.prinGuid = npm.prinGuid
        where
            memberRemoved <> @true
      ) added 
      left outer join tblPrincipalMembers existing on existing.prinID = added.prinID 
                                                      and existing.memberADPath = added.memberADPath
    where 
      existing.prinID is null
    insert into
      tblPrincipalMembers (prinID, memberADPath)
      select * from #temptblPrincipalMembers
 		
		--Mark processed entries in tblADUpdate
    delete from
      tblADUpdates
    delete from
      tblPrincipalMemberDifference
    if @@ERROR <> 0 
      rollback transaction
    else 
      commit transaction
    select
      count(*) as DirtyPrincipalCount
    from
      tblPrincipalMeta		
  end
GO
create procedure [dbo].[procGetADCookie]
  (
   @parmPrinGuid nvarchar(80)
  ,@parmLockSpanInSec int
  )
as 
    declare
    @result int
   ,@isLocked bit
   ,@now datetime
   ,@lockedUntil datetime
   ,@prinGuid uniqueidentifier
  set @isLocked = 1
  set @now = getutcdate()
  set @prinGuid = convert(uniqueidentifier, @parmPrinGuid)
  select
    @lockedUntil = lockedUntil
  from
    tblADCookie
  where
    prinGuid = @prinGuid
  if (@now >= @lockedUntil)
    begin
      set @isLocked = 0
      update
        tblADCookie
      set
        lockedUntil = DATEADD(S, @parmLockSpanInSec, @now)
      where
        prinGuid = @prinGuid
    end
	
  select
    prinGuid
   ,adcContent
   ,@isLocked isLocked
   ,prinDCHost
  from
    tblADCookie
  where
    prinGuid = @prinGuid
GO
create procedure [dbo].[procExtendADCookieLock]
  (
   @parmPrinGuid nvarchar(80)
   ,@parmLockSpanInSec int
  )
as 
  declare
    @lockedUntil datetime
   ,@prinGuid uniqueidentifier
	
  set @prinGuid = convert(uniqueidentifier, @parmPrinGuid)
  update
    tblADCookie
  set
    lockedUntil = DATEADD(S, @parmLockSpanInSec, getutcdate())
  where
    prinGuid = @prinGuid
GO
create procedure [dbo].[procSetADCookie]
  (
   @parmPrinGuid nvarchar(80)
  ,@parmDCHost nvarchar(255)
  ,@parmAdcContent image
  )
as 
  set transaction isolation level read committed
  declare @prinGuid as uniqueidentifier
  set @prinGuid = convert(uniqueidentifier, @parmPrinGuid)
  if exists ( select
                *
              from
                tblADCookie
              where
                prinGuid = @prinGuid) 
    update
      tblADCookie
    set
      adcContent = @parmAdcContent
     ,lastUpdated = getutcdate()
     ,lockedUntil = getutcdate()
     ,prinDCHost = @parmDCHost
    where
      prinGuid = @prinGuid
  else 
    insert into
      tblADCookie
      (
       prinGuid
      ,prinDCHost
      ,adcContent
      ,lastUpdated
      ,lockedUntil           
      )
    values
      (
       @prinGuid
      ,@parmDCHost
      ,@parmAdcContent
      ,getutcdate()
      ,getutcdate()
      )
  select
    count(*) as DirtyPrincipalCount
  from
    tblPrincipalMeta
  where
    tryCount < 1
    or nextTry is null
    or getutcdate() > nextTry	
GO
create procedure [dbo].[procInsertADUpdateEntry]
  (
   @parmPrinGuid nvarchar(80)
  ,@parmADPath nvarchar(384)
  ,@parmMembersChanged bit
  ,@parmDeleted bit
  )
as 
  begin
    set transaction isolation level read committed
    declare @prinGuid as uniqueidentifier
    set @prinGuid = convert(uniqueidentifier, @parmPrinGuid)
	
	-- do not insert duplicate entries into tblADUpdates
	-- insert only provisioned users and userGroups with no DG member changes
	
    if exists ( select
                  *
                from
                  tblADUpdates
                where
                  prinGuid = @prinGuid ) 
      update
        tblADUpdates
      set
        prinADPath = @parmADPath
       ,prinAttributesChanged = 'True'
       ,prinMembersChanged = @parmMembersChanged | prinMembersChanged
       ,prinDeleted = @parmDeleted | prinDeleted
      where
        prinGuid = @prinGuid
    else 
      if exists ( select
                    prinGuid
                  from
                    tblPrincipal
                  where
                    prinGuid = @prinGuid ) 
        insert into
          tblADUpdates
          (
           prinGuid
          ,prinADPath
          ,prinAttributesChanged
          ,prinMembersChanged
          ,prinDeleted
          )
        values
          (
           @prinGuid
          ,@parmADPath
          ,'True'
          ,@parmMembersChanged
          ,@parmDeleted
          )
  end
GO
create procedure [dbo].[procInsertPrincipalMembers]
  @parmPrinID int
 ,@parmMemberADPathList xml
as 
  begin
    declare
      @true bit
     ,@false bit
    select
      @true = 1
     ,@false = 0
    declare @newPrincipalMembers table ([entry] nvarchar(384))
    declare @dirtyPrincipals table ([prinID] int)
	
    insert into
      @newPrincipalMembers ([entry])
      select
        [entry]
      from
        fnParseDelimitedStringForString(@parmMemberADPathList) ids
	
    set nocount on
    set transaction isolation level read committed
    declare
      @Tc int
     ,@Sp varchar(10)
    select
      @Tc = @@trancount
     ,@Sp = @@procid
    if (@Tc = 0) 
      begin
        set transaction isolation level read committed
        begin transaction @Sp
      end
    else 
      begin
        save transaction @Sp
      end
    begin try
	-- delete the old principal members
      delete from
        tblPrincipalMembers
      where
        prinID = @parmPrinID
      insert into
        [tblPrincipalMembers] (prinID, memberADPath)
        select
          @parmPrinID
         ,pm.entry
        from
          @newPrincipalMembers pm
      insert into
        @dirtyPrincipals ([prinID])
        select distinct
          p.prinID
        from
          @newPrincipalMembers n
          inner join tblPrincipal p on n.entry = p.prinADPath
	-- if the principal is already in the set of dirty principals update the affiliaiton dirty flag
      update
        tblPrincipalMeta
      set
        prinAffiliationsDirty = @true
       ,tryCount = 0
       ,nextTry = null
      from
        tblPrincipalMeta pm
      where
        pm.prinID in (select
                        prinID
                      from
                        @dirtyPrincipals)
	
	-- if the principal is not in the set of dirty principals add an entry with affiliaiton dirty flag set to true
	
      insert into
        tblPrincipalMeta
        (
         prinID
        ,prinAffiliationsDirty
        ,prinAttributesDirty
        ,prinDeleted
        )
        select
          p.prinID
         ,@true
         ,@false
         ,@false
        from
          @dirtyPrincipals p
        where
          p.prinID not in (select
                            prinID
                           from
                            tblPrincipalMeta)
	
      if (@Tc = 0) 
        commit transaction @Sp
    end try
    begin catch
      exec RethrowError
      if (xact_state() <> 0) 
        begin
          rollback transaction @Sp
          return -1
        end
    end catch	
  end
GO
create procedure [dbo].[procPopulatePrincipalMemberDifference]
  @parmGroupGuid uniqueidentifier
  ,@parmGroupMemberDNsXml xml
as 
  begin
    declare @newPrincipalMembers table
    (
      memberADPath nvarchar(384)
    )
	
    insert into
      @newPrincipalMembers
    select
      ids.[entry] as memberADPath
    from
      fnParseDelimitedStringForString(@parmGroupMemberDNsXml) ids
    if not exists (select * from @newPrincipalMembers)
		insert into
			@newPrincipalMembers
		select
            null as memberADPath
			
	--delete groups we dont know(care) about. 
	--We care about groups where either the group is in the db or the groups member is in the db
    if not exists (select * from tblPrincipal
	                where
		                prinGuid = @parmGroupGuid 
		                or prinADPath in (select memberADPath from @newPrincipalMembers))
      delete from @newPrincipalMembers 
	begin transaction
	  
	-- clean up [tblPrincipalMemberDifference]
    delete from
      [tblPrincipalMemberDifference]
    where
      prinGuid = @parmGroupGuid
    insert into
      tblPrincipalMemberDifference
      select
        @parmGroupGuid as prinGuid
       ,case when (new.memberADPath is null) then old.memberADPath
             else new.memberADPath
        end as memberADPath
       ,case when (new.memberADPath is null) then 'True'
             else 'False'
        end as memberRemoved
      from
        (
         select
          memberADPath
         from
          tblPrincipalMembers pm
          inner join tblPrincipal p on p.prinID = pm.prinID
		 where
		  prinGuid = @parmGroupGuid
        ) old
        full outer join @newPrincipalMembers new 
			on old.memberADPath = new.memberADPath
      where
        (
         new.memberADPath is null
         or old.memberADPath is null
        )
        and (
             new.memberADPath is not null
             or old.memberADPath is not null
            )
	
    if @@ERROR <> 0 
      rollback transaction
    else 
      commit transaction
  end
GO
create procedure [dbo].[procUpdatePrincipalADPath]
  @parmPrinUpdatedOn bigint
as 
  begin
    declare
      @true bit
     ,@false bit
    select
      @true = 1
     ,@false = 0
    declare @changedPrincipals table
      (
       prinID int
      ,oldADPath nvarchar(384)
      ,newADPath nvarchar(384)
      )
  set nocount on
  declare
    @Tc int
   ,@Sp varchar(10)
  select
    @Tc = @@trancount
   ,@Sp = @@procid
  if (@Tc = 0) 
    begin
      set transaction isolation level read committed
      begin transaction @Sp
    end
  else 
    begin
      save transaction @Sp
    end
  begin try
	-- Update memberDNs for tblPrincipalMembers first
	-- unknown principals in delta should be fine
	
	insert into
      @changedPrincipals
      (
       prinID
      ,oldADPath
      ,newADPath
      )
    select distinct 
      p.prinID
     ,p.prinADPath as oldADPath
     ,ad.prinADPath as newADPath
    from
      tblPrincipal p
      join tblADUpdates ad on p.prinGuid = ad.prinGuid
    where
      p.prinADPath <> ad.prinADPath
	
	--delete members from groups if the members were deleted 
    delete 
      tblPrincipalMembers
    from
      tblPrincipalMembers pm
      join @changedPrincipals cp on pm.memberADPath = cp.oldADPath
	where
	  cp.newADPath = ''
	--delete members from groups if the group had both the oldADPath and the newADPath in its member list to prevent duplicate entries in tblPrincipalMembers
	--edge case: principal with ADPath gets deleted and a new principal with the same adpath is created
	delete 
		pm
	from
		tblPrincipalMembers pm
		join @changedPrincipals cp on pm.memberADPath = cp.oldADPath
		join tblPrincipalMembers pmNew on pm.prinID = pmNew.prinID and pmNew.memberADPath = cp.newADPath
	
	--update membersDNs if the members were not deleted
	update
      tblPrincipalMembers
    set
      memberADPath = cp.newADPath
    from
      tblPrincipalMembers pm
      join @changedPrincipals cp on pm.memberADPath = cp.oldADPath
    where
	  cp.newADPath <> ''
	-- Update memberDNs for tblPrincipal Second
		
    update
      tblPrincipal
    set
      prinADPath = cp.newADPath
     ,prinUpdatedBy = 1
     ,prinUpdatedOn = @parmPrinUpdatedOn
    from
      tblPrincipal p
      join @changedPrincipals cp on p.prinADPath = cp.oldADPath
	
    insert into
      tblPrincipalMeta
      (
       prinID
      ,prinAffiliationsDirty
      ,prinAttributesDirty
      ,prinDeleted
      )
      select distinct 
        prinID
       ,@true as prinAffiliationsDirty
       ,@true as prinAttributesDirty
       ,@false as prinDeleted
      from
        @changedPrincipals
      where
        prinID not in (select
                        prinID
                       from
                        tblPrincipalMeta)
	
    update
      tblPrincipalMeta
    set
      prinAffiliationsDirty = @true
     ,prinAttributesDirty = @true
     ,tryCount = 0
     ,nextTry = null
    from
      @changedPrincipals cp
      join tblPrincipalMeta pm on pm.prinID = cp.prinID
    insert into
      tblPrincipalMeta
      (
       prinID
      ,prinAffiliationsDirty
      ,prinAttributesDirty
      ,prinDeleted
      )
      select distinct 
        a.principalID
       ,@true as prinAffiliationsDirty
       ,@true as prinAttributesDirty
       ,@false as prinDeleted
      from
        @changedPrincipals cp
        join tblPrincipalAffiliations a on cp.prinID = a.affiliationID
      where
        a.principalID not in (select
								prinID
							  from
								tblPrincipalMeta)
	
    update
      tblPrincipalMeta
    set
      prinAffiliationsDirty = @true
     ,prinAttributesDirty = @true
     ,tryCount = 0
     ,nextTry = null
    from
      @changedPrincipals cp
      join tblPrincipalAffiliations a on cp.prinID = a.affiliationID
      join tblPrincipalMeta pm on pm.prinID = a.principalID
    update
      [tblPrincipal]
    set
      [prinVerifiedOn] = getutcdate()
    where
      [prinID] in (select
                    prinID
                   from
                    @changedPrincipals)
		      
    if (@Tc = 0) 
      commit transaction @Sp
  end try
  begin catch
    exec RethrowError
    if (xact_state() <> 0) 
      begin
        rollback transaction @Sp
        return -1
      end
  end catch
		
  end
GO
create procedure [dbo].[procGetDirtyPrincipalIds] @parmBatchSize int
as 
  begin
    declare @totalCount int  
    declare @true bit, @false bit
	set @true = 1
	set @false = 0
		
    select
      @totalCount = count(*)
    from
      tblPrincipalMeta
    where
      tryCount < 1
      or nextTry is null
      or getutcdate() > nextTry
	  
    select
      @totalCount as prinCount
	  
    if @parmBatchSize < 1
      or @parmBatchSize > @totalCount 
      set @parmBatchSize = @totalCount
	   
	--select and trim using exponential backoff
	
    declare @dirtyPrincipals table
      (
       prinID int
      ,prinAffiliationsDirty bit
      ,prinDeleted bit
      ,isInScopeOrRoleList bit
      ,tryCount int null
      )
	
    if @parmBatchSize > 0 
      begin
	
        insert into
          @dirtyPrincipals
          (
           prinID
          ,prinAffiliationsDirty
          ,prinDeleted
          ,isInScopeOrRoleList
          ,tryCount
          )
          select distinct top (@parmBatchSize)
            prinID
           ,prinAffiliationsDirty
           ,prinDeleted
           ,case when scope.[scopePrinID] is null and role.[prinRolePrinID] is null then @false else @true end as isInScopeOrRoleList
           ,tryCount
          from
            tblPrincipalMeta pm
            left outer join tblScopedPrincipal scope on scope.[scopePrinID] = pm.prinID
            left outer join tblPrincipalRole role on role.[prinRolePrinID] = pm.prinID
          where
            tryCount < 1
            or nextTry is null
            or getutcdate() > nextTry
          order by
            tryCount asc
			
		-- mark the principals so another server in the pool doesnt process them until atleast 20 seconds per principal refresh has passed by.
		--this ensures that only one of the servers in the pool processes this principal refresh
        update
          tblPrincipalMeta
        set
          tryCount = tryCount + 1
         ,nextTry = dateadd(second, 20 * @parmBatchSize, getutcdate())
        where
          prinID in (select
                      prinID
                     from
                      @dirtyPrincipals)
	
      end
		
	--process all the deleted principals first so the Uri's can be reused
    select
      prinID
     ,prinAffiliationsDirty
     ,prinDeleted
     ,isInScopeOrRoleList
    from
      @dirtyPrincipals
    order by
      prinDeleted desc
  end
GO
create procedure [dbo].[procRemoveDirtyFlagFromPrincipal] @parmPrinID int
as 
  begin
    if not exists ( select
                      *
                    from
                      tblSkippedAffiliations
                    where
                      prinID = @parmPrinID ) 
      begin
        delete from
          tblPrincipalMeta
        where
          prinID = @parmPrinID
      end
    update
      [tblPrincipal]
    set
      [prinVerifiedOn] = getutcdate()
    where
      [prinID] = @parmPrinID
		
  end
go
create procedure [dbo].[procGetPrincipalsToPoll]
  @parmPollIntervalMs int
 ,@parmBatchSize int
as 
  begin
    declare @staleThreshold datetime
    set @staleThreshold = dateadd(ms, -@parmPollIntervalMs, getutcdate())
    declare @principals table
      (
       [prinGuid] uniqueidentifier
      )
    insert into
      @principals ([prinGuid])
      select top (@parmBatchSize)
        prinGuid
      from
        tblPrincipal
      where
        prinVerifiedOn < @staleThreshold
        and prinDisabled <> 2 -- disabled but not yet deleted principals should still be polled.
	
    update
      tblPrincipal
    set
      prinVerifiedOn = dateadd(hour, 1, prinVerifiedOn)
    where
      prinGuid in (select
                    prinGuid
                   from
                    @principals)
    select
      prinGuid
    from
      @principals
  end
GO
create procedure [dbo].[procSetPollResults]
  @parmVerifiedPrincipals xml
 ,@parmDirtyPrincipals xml
as 
  begin
    declare @verifiedPrincipals table
      (
       [prinGuid] uniqueidentifier
      )
	
    insert into
      @verifiedPrincipals ([prinGuid])
      select
        cast([entry] as uniqueidentifier)
      from
        fnParseDelimitedStringForString(@parmVerifiedPrincipals) ids
    declare @dirtyPrincipals table
      (
       [prinGuid] uniqueidentifier
      )
	
    insert into
      @dirtyPrincipals ([prinGuid])
      select
        cast([entry] as uniqueidentifier)
      from
        fnParseDelimitedStringForString(@parmDirtyPrincipals) ids
    update
      [tblPrincipal]
    set
      [prinVerifiedOn] = getutcdate()
    where
      [prinGuid] in (select
                      prinGuid
                     from
                      @verifiedPrincipals)
		
    update
      [tblPrincipal]
    set
      [prinVerifiedOn] = getutcdate()
    where
      [prinGuid] in (select
                      prinGuid
                     from
                      @dirtyPrincipals)
		
	--makr the dirty principals for refresh if they have not already been marked
    insert into
      tblPrincipalMeta
      (
       prinID
      ,prinAffiliationsDirty
      ,prinAttributesDirty
      ,prinDeleted
      )
      select
        p.prinID
       ,'True' as prinAffiliationsDirty
       ,'True' as prinAttributesDirty
       ,'False' as prinDeleted
      from
        @dirtyPrincipals dp
        join tblPrincipal p on p.prinGuid = dp.prinGuid
      where
        prinID not in (select
                        prinID
                       from
                        tblPrincipalMeta)
	
    update
      tblPrincipalMeta
    set
      prinAffiliationsDirty = 'True'
     ,prinAttributesDirty = 'True'
     ,tryCount = 0
     ,nextTry = null
    from
      @dirtyPrincipals dp
      join tblPrincipal p on p.prinGuid = dp.prinGuid
      join tblPrincipalMeta pm on pm.prinID = p.prinID
  end
GO
go
create function [dbo].Exp_BitAsString (@bool bit)
returns nvarchar(5)
begin
  declare @result nvarchar(5)
  select
    @result = case @bool
                when null then null
                when 0 then 'false'
                when 1 then 'true'
              end
  return @result
end
go
create procedure [dbo].[Exp_Pool] (@isForPrefs bit)
as 
  declare
   @poolID uniqueidentifier
  select
    @poolID = [configPoolID]
  from
    [tblConfig]
	
  select
   @poolID "@poolId"
   ,'1.0' "@schemaVersion" 
  for   
    xml path('Pool')
go
create view [dbo].Exp_PrincipalView
as
  select
    p.[prinID] principalDbId
   ,cast(p.prinGuid as nvarchar(36)) principalID
   ,(case p.prinDisabled
       when 0 then 'false'
       else 'true'
     end) isDisabled  
   ,(case p.prinDisabled
       when 2 then 'true'
       else 'false'
     end) isDeleted  
   ,(case p.prinTypeID
       when 8 then 'DC'
       when 9 then 'Group'
       when 10 then 'Folder'
       else null
     end) groupType
   ,[dbo].[fnTicksToDate](p.prinAddedOn) addedOn
   ,case when a.[prinID] = 1 then null
         else a.prinGuid
    end addedBy
   ,[dbo].[fnTicksToDate](p.prinUpdatedOn) updatedOn
   ,case when u.[prinID] = 1 then null
         else u.prinGuid
    end updatedBy
   ,p.prinUri Uri
   ,p.prinName [Name]
   ,case when p.prinDisplayName = '' then null
         else p.prinDisplayName
    end DisplayName
   ,case when p.prinCompanyName = '' then null
         else p.prinCompanyName
    end CompanyName
   ,p.prinEmail Email
   ,p.prinADPath DistinguishedName
   ,p.prinADUserPrincipalName UserPrincipalName
   ,t.ptypeIsUser isUser
   ,p.prinPoolID poolID
   ,p.prinPolicyID policyID
  from
    tblPrincipalType t
    inner join tblPrincipal p on p.prinTypeID = t.ptypeID
    inner join tblPrincipal a on p.prinAddedBy = a.prinID
    inner join tblPrincipal u on p.prinUpdatedBy = u.prinID
  where
    t.ptypeIsSystemUser = 0
go
create procedure [dbo].Exp_AdUsers
as --with xmlnamespaces (default 'http://schemas.microsoft.com/GroupChat/2008/04/dbimpexp')
  select
    principalID "@principalId"
   ,isDisabled "@isDisabled"
   ,isDeleted "@isDeleted"
   ,poolID "@poolId"
   ,policyID "@policyId"
   ,addedOn "@addedOn"
   ,addedBy "@addedBy"
   ,updatedOn "@updatedOn"
   ,updatedBy "@updatedBy"
   ,Uri "Uri"
   ,[Name] "Name"
   ,DisplayName "DisplayName"
   ,CompanyName "CompanyName"
   ,Email "Email"
   ,DistinguishedName "DistinguishedName"
   ,UserPrincipalName "UserPrincipalName"
  from
    Exp_PrincipalView
  where
    isUser = 1
  order by
    case when updatedBy is null then 0
         when updatedBy = principalID then 1
         else 2
    end --simple algorithm to export users in an order they can be imported in without failing due to missing principals
								--  does not fix all cases, and there are some cases that cannot be fixed.
  for   
    xml path('User')
go
create procedure [dbo].Exp_AdGroups
as --with xmlnamespaces (default 'http://schemas.microsoft.com/GroupChat/2008/04/dbimpexp')
  select
    principalID "@principalId"
   ,isDisabled "@isDisabled"
   ,groupType "@groupType"
   ,addedOn "@addedOn"
   ,addedBy "@addedBy"
   ,updatedOn "@updatedOn"
   ,updatedBy "@updatedBy"
   ,[Name] "Name"
   ,DistinguishedName "DistinguishedName"
   ,UserPrincipalName "UserPrincipalName"
  from
    Exp_PrincipalView
  where
    isUser = 0
  for   
    xml path('Group')
go
create procedure [dbo].Exp_AdAffiliations
as --with xmlnamespaces (default 'http://schemas.microsoft.com/GroupChat/2008/04/dbimpexp')
  select
    users.principalID "@id"
   ,(
     select
      groups.[prinGuid] "@id"
     from
      [tblPrincipalAffiliations] pa
      inner join tblPrincipal groups on pa.[affiliationID] = groups.[prinID]
     where
      pa.[index] != -1
      and pa.principalID = users.principalDbId
    for
     xml path('Group')
        ,type
    ) as "Groups"
  from
    Exp_PrincipalView users
  for   
    xml path('User')		
go
go
create view [dbo].Exp_NodeView
as
  select
    n.[nodeID] nodeDbId
   ,n.nodeGuid nodeID
   ,case when p.[parentID] is null then null else p.nodeGuid end parentID --root node id will be null
   ,n.[nodeType] isCategory
   ,dbo.Exp_BitAsString(n.filePost) allowFilePost
   ,dbo.Exp_BitAsString(n.invite) isInvite
   ,dbo.Exp_BitAsString(n.logged) isLogged
   ,dbo.Exp_BitAsString(n.disabled) isDisabled
   ,case when n.nodeType = 1 then null
				 when n.behavior = 5 then 'Auditorium'
         else 'Normal'
    end behavior
   ,n.siopID
   ,case n.visibility when 2 then 'Private' 
                      when 3 then 'Scope'
                      when 6 then 'Open'
         else null
    end visibility
   ,[dbo].[fnTicksToDate](n.nodeAddedOn) addedOn
   ,case when a.[prinID] = 1 then null
         else a.prinGuid
    end addedBy
   ,[dbo].[fnTicksToDate](n.nodeUpdatedOn) updatedOn
   ,case when u.[prinID] = 1 then null
         else u.prinGuid
    end updatedBy
   ,n.nodeName [Name]
   ,n.nodeDesc [Desc]
  from
    tblNode n
    inner join tblPrincipal a on n.nodeAddedBy = a.prinID
    inner join tblPrincipal u on n.nodeUpdatedBy = u.prinID
    left outer join tblNode p on n.parentID = p.nodeID
  where
    p.[nodeID] is not null  
GO
create view [dbo].Exp_ScopeView
as
  select
    s.[scopeNodeID] nodeDbId
   ,p.[prinGuid] principalID
   ,s.[scopeIsDenied] isDenied
  from
    [tblScopedPrincipal] s
    inner join [tblPrincipal] p on s.scopePrinID = p.prinID
go
create view [dbo].Exp_RoleView
as
  select
    r.prinRoleNodeID nodeDbId
   ,p.prinGuid principalID
   ,max(r.isMember) isMember
   ,max(r.isManager) isManager
   ,max(r.isVoiced) isVoiced
   ,max(r.isCreator) isCreator
  from
    (
     select
      prinRoleNodeID
     ,prinRolePrinID
     ,1 isMember
     ,0 isManager
     ,0 isVoiced
     ,0 isCreator
     from
      tblPrincipalRole
     where
      prinRoleTypeID = 1
     union all
     select
      prinRoleNodeID
     ,prinRolePrinID
     ,0 isMember
     ,1 isManager
     ,0 isVoiced
     ,0 isCreator
     from
      tblPrincipalRole
     where
      prinRoleTypeID = 2
     union all
     select
      prinRoleNodeID
     ,prinRolePrinID
     ,0 isMember
     ,0 isManager
     ,1 isVoiced
     ,0 isCreator
     from
      tblPrincipalRole
     where
      prinRoleTypeID = 5
     union all
     select
      prinRoleNodeID
     ,prinRolePrinID
     ,0 isMember
     ,0 isManager
     ,0 isVoiced
     ,1 isCreator
     from
      tblPrincipalRole
     where
      prinRoleTypeID = 6
    ) r
    inner join tblPrincipal p on r.prinRolePrinID = p.prinID
  group by
    r.prinRoleNodeID
   ,p.prinGuid
GO
create view [dbo].Exp_ChatView
as
  select
    [channelId] channelDbId
   ,[chatId] id
   ,[dbo].[fnTicksToDate]([chatDate]) date
   ,[prinGuid] userId
   ,[isAlert] isAlert
   ,[content] [Content]
   ,[rtf] [Rtf]
  from
    [tblPrincipal] p
    inner join [tblChat] c on p.[prinID] = c.[userId]
go
create procedure Exp_Categories
as 
	--with xmlnamespaces (default 'http://schemas.microsoft.com/GroupChat/2008/04/dbimpexp')
  select
    nodeID "@nodeId"
   ,allowFilePost "@allowFilePost"
   ,isInvite "@isInvite"
   ,isLogged "@isLogged"
   ,addedBy "@addedBy"
   ,addedOn "@addedOn"
   ,updatedBy "@updatedBy"
   ,updatedOn "@updatedOn"
   ,[Name] "Name"
   ,[Desc] "Desc"
   ,(
     select
      principalID "@id"
     ,isDenied "@denied" 
     from
      [Exp_ScopeView]
     where
      [Exp_NodeView].[nodeDbId] = [Exp_ScopeView].[nodeDbId]
    for
     xml path('Principal')
        ,type
    ) as "Scope"
   ,(
     select
      principalID "@id"
     ,isManager "@isManager"
     ,isMember "@isMember"
     ,isVoiced "@isVoiced"
     ,isCreator "@isCreator"
     from
      [Exp_RoleView]
     where
      [Exp_NodeView].[nodeDbId] = [Exp_RoleView].[nodeDbId]
    for
     xml path('Principal')
        ,type
    ) as "Roles"
  from
    Exp_NodeView
  where
    isCategory = 1
  order by 
    parentID
  for   
    xml path('Category')
GO
create procedure Exp_ChatRooms
as 
	--with xmlnamespaces (default 'http://schemas.microsoft.com/GroupChat/2008/04/dbimpexp')
  select
    nodeID "@nodeId"
   ,parentID "@parentId"
   ,isInvite "@isInvite"
   ,isDisabled "@isDisabled"
   ,behavior "@behavior"
   ,siopID "@siopId"
   ,visibility "@visibility"
   ,addedBy "@addedBy"
   ,addedOn "@addedOn"
   ,updatedBy "@updatedBy"
   ,updatedOn "@updatedOn"
   ,[Name] "Name"
   ,[Desc] "Desc"
   ,(
     select
      principalID "@id"
     ,isManager "@isManager"
     ,isMember "@isMember"
     ,isVoiced "@isVoiced"
     ,isCreator "@isCreator"
     from
      [Exp_RoleView]
     where
      [Exp_NodeView].[nodeDbId] = [Exp_RoleView].[nodeDbId]
    for
     xml path('Principal')
        ,type
    ) as "Roles"
   ,(
     select
      id "@id"
     ,date "@date"
     ,userId "@userId"
     ,isAlert "@isAlert"
     ,[Content] "Content"
     ,[Rtf] "Rtf"
     from
      [Exp_ChatView]
     where
      [Exp_NodeView].[nodeDbId] = [Exp_ChatView].[channelDbId]
     order by id
    for
     xml path('Chat')
        ,type
    ) as "Chats"
  from
    Exp_NodeView
  where
    isCategory = 0
  for   
    xml path('ChatRoom')
GO
create procedure Exp_Siops
as 
	--with xmlnamespaces (default 'http://schemas.microsoft.com/GroupChat/2008/04/dbimpexp')
  select
    [siopID] "@id"
   ,[siopName] "@name"
   ,[siopUrl] "@url"
  from
    tblSiopWhiteList
  for   
    xml path('Siop')
go
create view [dbo].Exp_PrefView
as
     select
	  left(prefLabel, charindex('|', prefLabel) - 1) userUri
     ,right(prefLabel, len(prefLabel) - charindex('|', prefLabel)) label
     ,prefLabel fullLabel
     ,prefSeqID seqId
     ,prefContent [Content]
     from
      tblPreference
go
create procedure [dbo].Exp_Prefs
as 
	--with xmlnamespaces (default 'http://schemas.microsoft.com/GroupChat/2008/04/dbimpexp')
  select
    cast(prinGuid as nvarchar(36)) "@userId"
   ,(
     select
      label "@label"
     ,seqId "@seqId"
     ,[Content] "Content"
     from
      Exp_PrefView
     where
      userUri = tblPrincipal.prinUri collate Latin1_General_CI_AS
    for
     xml path('Preference')
        ,type
    ) as "Preferences"
  from
    tblPrincipal
  where
		[prinUri] collate Latin1_General_CI_AS in (select userUri from Exp_PrefView) 
  for   
    xml path('User')
go
create procedure [dbo].Imp_OverwritePool
  (
   @poolID uniqueidentifier
  )
as 
  update
    tblConfig
  set
    [configPoolID] = @poolID
go
create procedure [dbo].Imp_ImportIsValid
  (
   @domain nvarchar(256)
  ,@schemaVersion nvarchar(10)
  ,@isForPrefs bit
  )
as 
  if (@schemaVersion != '1.0') 
    begin
      raiserror (51107, 16, 1, @schemaVersion, '1.0')
      return -1
    end
go
set quoted_identifier on
go
create function [dbo].Imp_GetPrincipalType
  (
   @isUser bit
  ,@groupType nvarchar(6)
  )
returns nvarchar(100)
as begin
    declare @typeId int
    if @isUser = 1 
      begin
        set @typeId = 5
      end
    else 
      begin
        select
          @typeId = case @groupType
                      when 'DC' then 8
                      when 'Group' then 9
                      when 'Folder' then 10
                      else null
                    end
      end
    return @typeId
   end
go
create procedure [dbo].Imp_AdGroup
(
   @xml xml
  ,@insertOnly bit = 1
  ,@updated bit output
)
as
    declare 
   @groupId uniqueidentifier
  ,@name varchar(256)
  ,@distinguishedName varchar(256)
  ,@userPrincipalName varchar(256)
  ,@isDisabled bit
  ,@groupType varchar(6)
  ,@addedBy uniqueidentifier
  ,@addedOnDT datetime
  ,@updatedBy uniqueidentifier
  ,@updatedOnDT datetime
    select 
        @groupId = prin.value('@principalId', 'uniqueidentifier')
     ,@name = prin.value('data(Name)[1]', 'nvarchar(256)')
     ,@distinguishedName = prin.value('data(DistinguishedName)[1]', 'nvarchar(256)')
     ,@userPrincipalName = prin.value('data(UserPrincipalName)[1]', 'nvarchar(256)')
     ,@groupType = prin.value('@groupType', 'nvarchar(6)')
     ,@isDisabled = isnull(prin.value('@isDisabled', 'bit'), 0)
     ,@addedBy = prin.value('@addedBy', 'uniqueidentifier')
     ,@addedOnDT = prin.value('@addedOn', 'datetime')
     ,@updatedBy = prin.value('@updatedBy', 'uniqueidentifier')
     ,@updatedOnDT = prin.value('@updatedOn', 'datetime')
    from @xml.nodes('Group') adGroup(prin)
  declare
    @groupDbId int
   ,@addedByDbId int
   ,@updatedByDbId int
   ,@prinType int
   ,@uri nvarchar(256)
   ,@addedOn bigint
   ,@updatedOn bigint
   select @addedOn = [dbo].fnDateToTicks(@addedOnDT), @updatedOn = [dbo].fnDateToTicks(@updatedOnDT)
  select
    @groupDbId = prinID
  from
    tblPrincipal
  where
    prinGuid = @groupId
  if @groupDbId is not null
    and @insertOnly = 1 
    begin
      declare @idString nvarchar(36)
      set @idString = cast(@groupId as nvarchar(36))
      raiserror (51100, 16, 1, 'AD group', @idString)
      return -1
    end
  if (@addedBy is null) 
    set @addedByDbId = 1
  else 
    begin
      select
        @addedByDbId = prinID
      from
        tblPrincipal
      where
        prinGuid = @addedBy
      if @addedByDbId is null 
        begin
                    declare @addedByString nvarchar(36)
                    set @addedByString = cast(@addedBy as nvarchar(36))
                    raiserror (51101, 16, 1, @addedByString)
          return -1
        end
    end
  if (@updatedBy is null) 
    set @updatedByDbId = 1
  else 
    begin
      select
        @updatedByDbId = prinID
      from
        tblPrincipal
      where
        prinGuid = @updatedBy
      if @updatedByDbId is null 
        begin
                    declare @updatedByString nvarchar(36)
                    set @updatedByString = cast(@updatedBy as nvarchar(36))
                    raiserror (51102, 16, 1, @updatedByString)
          return -1
        end
    end    
  select
    @prinType = dbo.Imp_GetPrincipalType(0, @groupType)
   ,@uri = 'ma-grp:' + cast(@groupId as nvarchar(36)) + '@u.g'
  set xact_abort on
  begin transaction
  if @groupDbId is null --group does not exist
    begin
      exec procInsertPrincipal_p @parmPrinName = @name, @parmPrinDispName = null, @parmPrinCompany = null,
        @parmPrinGuid = @groupId, @parmPrinUri = @uri, @parmPrinEmail = null, @parmPrinADPath = @distinguishedName,
        @parmPrinADUserName = @userPrincipalName, @parmPrinDisabled = @isDisabled, @parmPrinTypeID = @prinType,
        @parmPrinAddedBy = @addedByDbId, @parmPrinAddedOn = @addedOn, @parmPrinUpdatedBy = @updatedByDbId,
        @parmPrinUpdatedOn = @updatedOn, @parmPrinPoolID = null, @parmPrinPolicyID = null,
        @parmPrinID = @groupDbId output
      set @updated = 0
    end
  else 
    begin
      exec procUpdatePrincipal_p @parmUserID = @groupDbId, @parmPrinName = @name, @parmPrinDispName = null,
        @parmPrinCompany = null, @parmPrinGuid = @groupId, @parmPrinUri = @uri, @parmPrinEmail = null,
        @parmPrinADPath = @distinguishedName, @parmPrinADUserName = @userPrincipalName, @parmDisabled = @isDisabled,
        @parmPrinTypeID = @prinType, @parmPrinAddedBy = @addedByDbId, @parmPrinAddedOn = @addedOn, 
        @parmPrinUpdatedBy = @updatedByDbId, @parmPrinUpdatedOn = @updatedOn, @parmPrinPoolID = null, @parmPrinPolicyID = null
      set @updated = 1
    end
        if exists(select * from [tblPrincipalMeta] where prinID = @groupDbId)
                update [tblPrincipalMeta] set [prinAffiliationsDirty] = 1, [prinAttributesDirty] = 1 where [prinID] = @groupDbId
        else
            insert into [tblPrincipalMeta] (
                [prinID],
                [prinAffiliationsDirty],
                [prinAttributesDirty],
                [prinDeleted]
            ) values ( 
                @groupDbId ,
                1 ,
                1 ,
                0 ) 
  commit transaction
GO
create procedure [dbo].Imp_AdUser
(
  @xml xml
 ,@insertOnly bit = 1
 ,@updated bit output
)
as
    declare 
      @userId uniqueidentifier
     ,@name varchar(256)
     ,@distinguishedName varchar(256)
     ,@userPrincipalName varchar(256)
     ,@uri varchar(256)
     ,@displayName varchar(256)
     ,@email varchar(256)
     ,@companyName varchar(256)
     ,@isDisabled bit
     ,@isDeleted bit
     ,@poolID int
     ,@policyID int
     ,@addedBy uniqueidentifier
     ,@addedOnDT datetime
     ,@updatedBy uniqueidentifier
     ,@updatedOnDT datetime
     ,@disableADSync bit
    select 
        @userId = prin.value('@principalId', 'uniqueidentifier')
     ,@name = prin.value('data(Name)[1]', 'nvarchar(256)')
     ,@distinguishedName = prin.value('data(DistinguishedName)[1]', 'nvarchar(256)')
     ,@userPrincipalName = prin.value('data(UserPrincipalName)[1]', 'nvarchar(256)')
     ,@uri = prin.value('data(Uri)[1]', 'nvarchar(256)')
     ,@displayName = prin.value('data(DisplayName)[1]', 'nvarchar(256)')
     ,@email = prin.value('data(Email)[1]', 'nvarchar(256)')
     ,@companyName = prin.value('data(CompanyName)[1]', 'nvarchar(256)')
     ,@isDisabled = isnull(prin.value('@isDisabled', 'bit'), 0)
     ,@isDeleted = isnull(prin.value('@isDeleted', 'bit'), 0)
     ,@poolID = prin.value('@poolId', 'int')
     ,@policyID = prin.value('@policyId', 'int')
     ,@addedBy = prin.value('@addedBy', 'uniqueidentifier')
     ,@addedOnDT = prin.value('@addedOn', 'datetime')
     ,@updatedBy = prin.value('@updatedBy', 'uniqueidentifier')
     ,@updatedOnDT = prin.value('@updatedOn', 'datetime')
     ,@disableADSync = isnull(prin.value('@disableADSync', 'bit'), 0)
    from 
        @xml.nodes('User') adUser(prin)
  declare
    @userDbId int
   ,@addedByDbId int
   ,@updatedByDbId int
   ,@prinType int
   ,@disabledField smallint
   ,@addedOn bigint
   ,@updatedOn bigint
   ,@updatedBySelf bit --ad user will always be added by the system user, buy they can update themselves
   select @addedOn = [dbo].fnDateToTicks(@addedOnDT), @updatedOn = [dbo].fnDateToTicks(@updatedOnDT)
  select
    @userDbId = prinID
  from
    tblPrincipal
  where
    prinGuid = @userId
  if @userDbId is not null
    and @insertOnly = 1 
    begin
      declare @idString nvarchar(36)
      set @idString = cast(@userId as nvarchar(36))
      raiserror (51100, 16, 1, 'AD user', @idString)
      return -1
    end
  if (@addedBy is null) 
    set @addedByDbId = 1
  else 
    begin
      select
        @addedByDbId = prinID
      from
        tblPrincipal
      where
        prinGuid = @addedBy
      if @addedByDbId is null 
        begin
                    declare @addedByString nvarchar(36)
                    set @addedByString = cast(@addedBy as nvarchar(36))
                    raiserror (51101, 16, 1, @addedByString)
          return -1
        end
    end
  if (@updatedBy is null)
    set @updatedByDbId = 1
  else 
    begin
      select
        @updatedByDbId = prinID
      from
        tblPrincipal
      where
        prinGuid = @updatedBy
      if @updatedByDbId is null
        begin
                    if (@updatedBy = @userId)
                        begin
                            set @updatedByDbId = 1
                            set @updatedBySelf = 1
                        end
                    else
                        begin
                            declare @updatedByString nvarchar(36)
                            set @updatedByString = cast(@updatedBy as nvarchar(36))
                            raiserror (51102, 16, 1, @updatedByString)
                            return -1
                        end
        end
    end
  select
    @prinType = dbo.Imp_GetPrincipalType(1, null)
   ,@disabledField = 0
  if (@isDeleted = 1)
    set @disabledField = 2
  else if (@isDisabled = 1)
    set @disabledField = 1     
  set xact_abort on
  begin transaction
        if @userDbId is null --user does not exist
            begin
                exec procInsertPrincipal_p @parmPrinName = @name, @parmPrinDispName = @displayName, @parmPrinCompany = @companyName,
                    @parmPrinGuid = @userId, @parmPrinUri = @uri, @parmPrinEmail = @email, @parmPrinADPath = @distinguishedName,
                    @parmPrinADUserName = @userPrincipalName, @parmPrinDisabled = @disabledField, @parmPrinTypeID = @prinType,
                    @parmPrinAddedBy = @addedByDbId, @parmPrinAddedOn = @addedOn, @parmPrinUpdatedBy = @updatedByDbId,
                    @parmPrinUpdatedOn = @updatedOn, @parmPrinPoolID = @poolID, @parmPrinPolicyID = @policyID,
                    @parmPrinID = @userDbId output
                set @updated = 0
            end
        else 
            begin
                exec procUpdatePrincipal_p @parmUserID = @userDbId, @parmPrinName = @name, @parmPrinDispName = @displayName,
                    @parmPrinCompany = @companyName, @parmPrinGuid = @userId, @parmPrinUri = @uri, @parmPrinEmail = @email,
                    @parmPrinADPath = @distinguishedName, @parmPrinADUserName = @userPrincipalName, @parmDisabled = @disabledField,
                    @parmPrinTypeID = @prinType, @parmPrinAddedBy = @addedByDbId, @parmPrinAddedOn = @addedOn, 
                    @parmPrinUpdatedBy = @updatedByDbId, @parmPrinUpdatedOn = @updatedOn,
                    @parmPrinPoolID = @poolID, @parmPrinPolicyID = @policyID
                set @updated = 1
            end
        if(@updatedBySelf = 1)
            begin
                update [tblPrincipal]
                set [prinUpdatedBy] = @userDbId
                where [prinID] = @userDbId
            end
        if (@disableADSync = 0)
        begin
            if exists(select * from [tblPrincipalMeta] where prinID = @userDbId)
                update [tblPrincipalMeta] set [prinAffiliationsDirty] = 1, [prinAttributesDirty] = 1 where [prinID] = @userDbId
            else
                insert into [tblPrincipalMeta] (
                    [prinID],
                    [prinAffiliationsDirty],
                    [prinAttributesDirty],
                    [prinDeleted]
                ) values ( 
                    @userDbId ,
                    1 ,
                    1 ,
                    0 )
        end         
  commit transaction
GO
create procedure [dbo].Imp_AdAffiliations
(
    @xml xml
 ,@insertOnly bit = 1
 ,@updated bit output
)
as
    declare 
        @userId uniqueidentifier
   ,@userDbId int
   ,@idString nvarchar(36)
    select 
        @userId = prin.value('@id', 'uniqueidentifier')
    from 
        @xml.nodes('User') adUser(prin)
  select
    @userDbId = prinID
  from
    tblPrincipal
  where
    prinGuid = @userId
  if @userDbId is null
    begin
      set @idString = cast(@userId as nvarchar(36))
      raiserror (50200, 16, 1, @idString)
      return -1
    end
    set @updated = 0
  if exists(select * from [tblPrincipalAffiliations] where [principalID] = @userDbId and [index] != -1)
    begin
            if @insertOnly = 1
                begin
                    set @idString = cast(@userId as nvarchar(36))
                    raiserror (51103, 16, 1, 'Affiliations', @idString)
                    return -1
                end
            else
                set @updated = 1
    end
  declare @affiliations table
    (
     prinID uniqueidentifier not null
    ,prinDbId int
    )
  insert into
    @affiliations
    select
      s.value('@id', 'nvarchar(36)')
     ,p.prinID
    from
      @xml.nodes('User/Groups/Group') scope (s)
      left outer join tblPrincipal p on p.prinGuid = s.value('@id', 'nvarchar(36)')
  if exists ( select
                *
              from
                @affiliations
              where
                prinDbId is null ) 
    begin
      declare @invalidAffiliationsString nvarchar(max)
      set @invalidAffiliationsString = ''
      select
        @invalidAffiliationsString = @invalidAffiliationsString + ', ' + cast(prinID as nvarchar(36))
      from
        @affiliations
      where
        prinDbId is null
      set @invalidAffiliationsString = substring(@invalidAffiliationsString, 2, len(@invalidAffiliationsString))
      raiserror (50200, 16, 1, @invalidAffiliationsString)
      return -1
    end
  set xact_abort on
  begin transaction
        if @updated = 1
            begin
                delete from [tblPrincipalAffiliations] where [principalID] = @userDbId and [index] != -1
            end
        declare @dbIdList nvarchar(max)    
        set @dbIdList = '<ROOT>'
        select
            @dbIdList = @dbIdList + '<r id="' + cast(prinDbId as nvarchar) + '"/>'
        from
            @affiliations
        set @dbIdList = @dbIdList + '</ROOT>'
        exec [procInsertPrincipalAffiliationByID] @principalID = @userDbId, @affiliationIdList = @dbIdList, @updater = 1
        if exists(select * from [tblPrincipalMeta] where prinID = @userDbId)
                update [tblPrincipalMeta] set [prinAffiliationsDirty] = 1 where [prinID] = @userDbId
        else
            insert into [tblPrincipalMeta] (
                [prinID],
                [prinAffiliationsDirty],
                [prinAttributesDirty],
                [prinDeleted]
            ) values ( 
                @userDbId ,
                1 ,
                0 ,
                0 ) 
  commit transaction
go
set quoted_identifier on
go
create procedure dbo.Imp_Scope_p (@nodeDbId int, @xml xml)
as --exit early if there is no scope
  if (@xml.exist('Scope/Principal') != 1) 
    return
  declare @scope table
    (
     prinID uniqueidentifier not null
    ,prinUri nvarchar(256)
    ,isDenied int
    )
	--collect scope
  insert into
    @scope
    select
      s.value('@id', 'nvarchar(36)')
     ,p.prinUri
     ,s.value('@denied', 'bit')
    from
      @xml.nodes('Scope/Principal') scope (s)
      left outer join tblPrincipal p on p.prinGuid = s.value('@id', 'nvarchar(36)')
	--assert all principals exist
  if exists ( select
                *
              from
                @scope
              where
                prinUri is null ) 
    begin
      declare @invalidScopeString nvarchar(max)
      set @invalidScopeString = ''
      select
        @invalidScopeString = @invalidScopeString + ', ' + cast(prinID as nvarchar(36))
      from
        @scope
      where
        prinUri is null
      set @invalidScopeString = substring(@invalidScopeString, 2, len(@invalidScopeString))
      raiserror (50200, 16, 1, @invalidScopeString)
      return -1
    end
	--add principals to scope
  declare @uriList nvarchar(max)    
  set @uriList = '<ROOT>'
  select
    @uriList = @uriList + '<r k="' + prinUri + '" v="' + cast(isDenied as nvarchar(1)) + '"/>'
  from
    @scope
  set @uriList = @uriList + '</ROOT>'
  exec [procInsertScopedByUri_p] @nodeDbId, @uriList, 1 
go
create procedure dbo.Imp_Role_p (@nodeDbId int, @roleID int, @applyScoping bit, @updatedBy int, @uriList xml)
as
  if (@applyScoping = 0)
  begin
    declare @errMsgs table (
        [errCode] int,
        [uris] nvarchar(max) collate Latin1_General_CI_AS
        )
    insert into @errMsgs
      exec [dbo].[procCheckPrins]
             @nodeDbId,
             @roleID,
             @uriList
    if exists (select * from @errMsgs)
    begin
      declare @errCode int
      declare @uris nvarchar(256)
      select top 1 @errCode = errCode, @uris = uris from @errMsgs
      raiserror (@errCode, 16, 1, @uris)
      return -1
    end
  end
  else   
  begin
    declare @prinsToAdd table (
        [uri] nvarchar(256) collate Latin1_General_CI_AS
        )
    insert into @prinsToAdd
      exec [dbo].[procScopePrins_p]
             @nodeDbId,
             @roleID,
             @uriList
    declare @uriListStr nvarchar(max)
    set @uriListStr = '<ROOT>'
    select
      @uriListStr = @uriListStr + '<r id="' + uri + '"/>'
    from
      @prinsToAdd
    set @uriListStr = @uriListStr + '</ROOT>'
    set @uriList = @uriListStr
  end
  exec procAddToRole @nodeDbId, @roleID, @updatedBy, @uriList, 0
go
create procedure dbo.Imp_Roles_p (@nodeDbId int, @xml xml, @forbidMembers bit = 0, @forbidPresenters bit = 0)
as --exit early if there are no roles
  if (@xml.exist('Roles/Principal') != 1) 
    return
  declare @membersNeedScoping bit = 0
  if (@xml.exist('Roles[@membersNeedScoping = "true"]') = 1)
      set @membersNeedScoping = 1
  declare @role table
    (
     prinID uniqueidentifier not null
    ,prinUri nvarchar(256)
    ,isManager bit
    ,isMember bit
    ,isVoiced bit
    ,isCreator bit
    ,isFormerManager bit
    )
	--collect roles
  insert into
    @role
    select
      r.value('@id', 'nvarchar(36)')
     ,p.prinUri
     ,r.value('@isManager', 'bit')
     ,r.value('@isMember', 'bit')
     ,r.value('@isVoiced', 'bit')
     ,r.value('@isCreator', 'bit')
     ,r.value('@isFormerManager', 'bit')
    from
      @xml.nodes('Roles/Principal') roles (r)
      left outer join tblPrincipal p on p.prinGuid = r.value('@id', 'nvarchar(36)')
  if (@forbidMembers = 1)
	update @role set isMember = 0
  if (@forbidPresenters = 1)
	update @role set isVoiced = 0
	--assert all principals exist
  if exists ( select
                *
              from
                @role
              where
                prinUri is null ) 
    begin
      declare @invalidRoleString nvarchar(36)
      set @invalidRoleString = ''
      select
        @invalidRoleString = @invalidRoleString + ', ' + cast(prinID as nvarchar(36))
      from
        @role
      where
        prinUri is null
      set @invalidRoleString = substring(@invalidRoleString, 2, len(@invalidRoleString))
      raiserror (50200, 16, 1, @invalidRoleString)
      return -1
    end
	--add principals to roles
  declare @uriList nvarchar(max)
  if exists ( select
                *
              from
                @role
              where
                isManager = 1 ) 
    begin
      set @uriList = '<ROOT>'
      select
        @uriList = @uriList + '<r id="' + prinUri + '"/>'
      from
        @role
      where
        isManager = 1
      set @uriList = @uriList + '</ROOT>'
      exec Imp_Role_p @nodeDbId, 2, 0, 1, @uriList
    end
  if exists ( select
                *
              from
                @role
              where
                isMember = 1 ) 
    begin
      set @uriList = '<ROOT>'
      select
        @uriList = @uriList + '<r id="' + prinUri + '"/>'
      from
        @role
      where
        isMember = 1
      set @uriList = @uriList + '</ROOT>'
      exec Imp_Role_p @nodeDbId, 1, @membersNeedScoping, 1, @uriList
    end
  if exists ( select
                *
              from
                @role
              where
                isVoiced = 1 ) 
    begin
      set @uriList = '<ROOT>'
      select
        @uriList = @uriList + '<r id="' + prinUri + '"/>'
      from
        @role
      where
        isVoiced = 1
      set @uriList = @uriList + '</ROOT>'
      exec Imp_Role_p @nodeDbId, 5, 1, 1, @uriList
    end
  if exists ( select
                *
              from
                @role
              where
                isCreator = 1 ) 
    begin
      if exists ( select
                *
              from
                @role
              where
                isCreator = 1 and isFormerManager = 1)
      begin
        set @uriList = '<ROOT>'
        select
          @uriList = @uriList + '<r id="' + prinUri + '"/>'
        from
          @role
        where
          isCreator = 1 and isFormerManager = 1
        set @uriList = @uriList + '</ROOT>'
        exec Imp_Role_p @nodeDbId, 6, 0, 1, @uriList
      end
      if exists ( select
                *
              from
                @role
              where
                isCreator = 1 and isFormerManager = 0)
      begin
        set @uriList = '<ROOT>'
        select
          @uriList = @uriList + '<r id="' + prinUri + '"/>'
        from
          @role
        where
          isCreator = 1 and isFormerManager = 0
        set @uriList = @uriList + '</ROOT>'
        exec Imp_Role_p @nodeDbId, 6, 1, 1, @uriList
      end
    end
go
create procedure [dbo].Imp_Category
  (
   @xml xml
  ,@insertOnly bit = 1
  ,@updated bit output
  )
as 
  declare
		--attributes
    @allowFilePost bit
   ,@isInvite bit
   ,@isLogged bit
   ,@nodeID uniqueidentifier
   ,@parentID uniqueidentifier
		--audit data
   ,@addedOnDT datetime
   ,@addedBy uniqueidentifier
   ,@updatedOnDT datetime
   ,@updatedBy uniqueidentifier
		--elements
   ,@desc nvarchar(256)
   ,@name nvarchar(256)
	--collect node details
  select
		--attributes
    @nodeID = category.value('@nodeId', 'uniqueidentifier')
   ,@allowFilePost = category.value('@allowFilePost', 'bit')
   ,@isInvite = category.value('@isInvite', 'bit')
   ,@isLogged = category.value('@isLogged', 'bit')
		--audit data
   ,@addedBy = category.value('@addedBy', 'uniqueidentifier')
   ,@addedOnDT = category.value('@addedOn', 'datetime')
   ,@updatedBy = category.value('@updatedBy', 'uniqueidentifier')
   ,@updatedOnDT = category.value('@updatedOn', 'datetime')
		--elements
   ,@desc = category.value('data(Desc)[1]', 'nvarchar(256)')
   ,@name = category.value('data(Name)[1]', 'nvarchar(256)')
  from
    @xml.nodes('Category') c (category)
  declare
    @nodeDbId int
   ,@parentDbId int
   ,@addedByDbId int
   ,@updatedByDbId int
   ,@addedOn bigint
   ,@updatedOn bigint
  select
    @addedOn = [dbo].fnDateToTicks(@addedOnDT)
   ,@updatedOn = [dbo].fnDateToTicks(@updatedOnDT)
	--assert node does not exist or update is allowed
  select
    @nodeDbId = nodeID
  from
    tblNode
  where
    nodeGuid = @nodeID
  if @nodeDbId is not null
    and @insertOnly = 1 
    begin
			declare @nodeIDString nvarchar(36)
			set @nodeIDString = cast(@nodeID as nvarchar(36))
      raiserror (51100, 16, 1, 'Category', @nodeIDString)
      return -1
    end
	--retrieve the root category
  select
    @parentDbId = nodeID
   ,@parentID = nodeGuid
  from
    tblNode
  where
    [parentID] is null
  if @parentDbId is null 
    begin
      declare @parentIDString nvarchar(36)
      set @parentIDString = cast(@parentID as nvarchar(36))
      raiserror (51104, 16, 1, @parentIDString)
      return -1
    end
	--assert added by user exists
  if (@addedBy is null) 
    set @addedByDbId = 1
  else 
    begin
      select
        @addedByDbId = prinID
      from
        tblPrincipal
      where
        prinGuid = @addedBy
				
      if @addedByDbId is null 
        begin
          declare @addedByString nvarchar(36)
          set @addedByString = cast(@addedBy as nvarchar(36))
					raiserror (51101, 16, 1, @addedByString)
          return -1
        end
    end
	--assert updated by user exists
  if (@updatedBy is null) 
    set @updatedByDbId = 1
  else 
    begin
      select
        @updatedByDbId = prinID
      from
        tblPrincipal
      where
        prinGuid = @updatedBy
				
      if @updatedByDbId is null 
        begin
          declare @updatedByString nvarchar(36)
          set @updatedByString = cast(@updatedBy as nvarchar(36))
					raiserror (51102, 16, 1, @updatedByString)
          return -1
        end
    end
  set xact_abort on
  begin transaction
  begin try
    if @nodeDbId is not null 
      begin
        delete from
          tblScopedPrincipal
        where
          scopeNodeID = @nodeDbId
        delete from
          tblPrincipalRole
        where
          prinRoleNodeID = @nodeDbId
        exec procUpdateNode @parm_dbId = @nodeDbId, @parm_parentID = @parentDbId, @parm_nodeType = 1,
          @parm_nodeName = @name, @parm_nodeDesc = @desc, @parm_behavior = 4,
          @parm_nodeUpdatedBy = @updatedByDbId,
          @parm_nodeUpdatedOn = @updatedOn, @parm_visibility = 1, @parm_invite = @isInvite,
          @parm_logged = @isLogged, @parm_filePost = @allowFilePost, @parm_disabled = 0,
          @parm_siopID = null
        set @updated = 1
      end
    else 
      begin
        exec [procInsertNode_p] @parm_nodeID = @nodeID, @parm_parentID = @parentDbId, @parm_nodeType = 1,
          @parm_nodeName = @name, @parm_nodeDesc = @desc, @parm_behavior = 4,
          @parm_nodeAddedBy = @addedByDbId, @parm_nodeAddedOn = @addedOn,
          @parm_nodeUpdatedBy = @updatedByDbId, @parm_nodeUpdatedOn = @updatedOn,
          @parm_visibility = 1, @parm_invite = @isInvite, @parm_logged = @isLogged,
          @parm_filePost = @allowFilePost, @parm_disabled = 0, @parm_siopID = null,
          @parm_dbId = @nodeDbId out			
        set @updated = 0
      end
    declare @innerXml xml
    select
      @innerXml = room.query('.')
    from
      @xml.nodes('Category/Scope') chat (room)
    exec Imp_Scope_p @nodeDbId, @innerXml
    select
      @innerXml = room.query('.')
    from
      @xml.nodes('Category/Roles') chat (room)
    exec Imp_Roles_p @nodeDbId, @innerXml
    commit transaction
  end try
  begin catch
		exec RethrowError
    return -1
  end catch
GO
create procedure [dbo].Imp_ChatRoom
  (
   @xml xml
  ,@insertOnly bit = 1
  ,@updated bit output
  )
as 
  declare
    @nodeID uniqueidentifier
   ,@parentID uniqueidentifier
   ,@name nvarchar(256)
   ,@desc nvarchar(256)
   ,@isInvite bit
   ,@isDisabled bit
   ,@behaviorEnum nvarchar(10)
   ,@siopID uniqueidentifier
   ,@visibilityEnum nvarchar(10)
   ,@addedOnDT datetime
   ,@addedBy uniqueidentifier
   ,@updatedOnDT datetime
   ,@updatedBy uniqueidentifier
	--collect node details
  select
    @nodeID = room.value('@nodeId', 'uniqueidentifier')
   ,@parentID = room.value('@parentId', 'uniqueidentifier')
   ,@isInvite = room.value('@isInvite', 'bit')
   ,@isDisabled = room.value('@isDisabled', 'bit')
   ,@behaviorEnum = room.value('@behavior', 'nvarchar(10)')
   ,@siopID = room.value('@siopId', 'uniqueidentifier')
   ,@visibilityEnum = room.value('@visibility', 'nvarchar(10)')
   ,@addedBy = room.value('@addedBy', 'uniqueidentifier')
   ,@addedOnDT = room.value('@addedOn', 'datetime')
   ,@updatedBy = room.value('@updatedBy', 'uniqueidentifier')
   ,@updatedOnDT = room.value('@updatedOn', 'datetime')
   ,@name = room.value('data(Name)[1]', 'nvarchar(256)')
   ,@desc = room.value('data(Desc)[1]', 'nvarchar(256)')
  from
    @xml.nodes('ChatRoom') chat (room)
  declare
    @nodeDbId int
   ,@parentDbId int
   ,@behavior smallint
   ,@visibility smallint
   ,@addedByDbId int
   ,@updatedByDbId int
   ,@addedOn bigint
   ,@updatedOn bigint
  select
    @addedOn = [dbo].fnDateToTicks(@addedOnDT)
   ,@updatedOn = [dbo].fnDateToTicks(@updatedOnDT)
   ,@behavior = case @behaviorEnum
                  when 'Auditorium' then 5
                  when 'Normal' then 4
                  else 4
                end
   ,@visibility = case @visibilityEnum
                    when 'Private' then 2
                    when 'Scope' then 3
                    when 'Open' then 6
                    else 3
                  end
   ,@isInvite = case @isInvite
                  when 0 then 0
                  else null
                end  
	--assert node does not exist or update is allowed
  select
    @nodeDbId = nodeID
  from
    tblNode
  where
    nodeGuid = @nodeID
  if @nodeDbId is not null
    and @insertOnly = 1 
    begin
			declare @nodeIDString nvarchar(36)
			set @nodeIDString = cast(@nodeID as nvarchar(36))
      raiserror (51100, 16, 1, 'Chat room', @nodeIDString)
      return -1
    end
	--assert parent exists
  select
    @parentDbId = nodeID
   ,@parentID = nodeGuid
  from
    tblNode
  where
    (
     @parentID is not null
     and nodeGuid = @parentID
    )
    or @parentID is null
  if @parentDbId is null 
    begin
      declare @parentIDString nvarchar(36)
      set @parentIDString = cast(@parentID as nvarchar(36))
      raiserror (51104, 16, 1, @parentIDString)
      return -1
    end
	--assert added by user exists
  if (@addedBy is null) 
    set @addedByDbId = 1
  else 
    begin
      select
        @addedByDbId = prinID
      from
        tblPrincipal
      where
        prinGuid = @addedBy
				
      if @addedByDbId is null 
        begin
          declare @addedByString nvarchar(36)
          set @addedByString = cast(@addedBy as nvarchar(36))
					raiserror (51101, 16, 1, @addedByString)
          return -1
        end
    end
	--assert updated by user exists
  if (@updatedBy is null) 
    set @updatedByDbId = 1
  else 
    begin
      select
        @updatedByDbId = prinID
      from
        tblPrincipal
      where
        prinGuid = @updatedBy
				
      if @updatedByDbId is null 
        begin
          declare @updatedByString nvarchar(36)
          set @updatedByString = cast(@updatedBy as nvarchar(36))
					raiserror (51102, 16, 1, @updatedByString)
          return -1
        end
    end
  begin try
    if @nodeDbId is not null 
      begin
        delete from
          tblPrincipalRole
        where
          prinRoleNodeID = @nodeDbId
        delete from
          tblChat
        where
          channelId = @nodeDbId
        exec procUpdateNode @parm_dbId = @nodeDbId, @parm_parentID = @parentDbId, @parm_nodeType = 0,
          @parm_nodeName = @name, @parm_nodeDesc = @desc, @parm_behavior = @behavior,
          @parm_nodeUpdatedBy = @updatedByDbId, @parm_nodeUpdatedOn = @updatedOn,
          @parm_visibility = @visibility, @parm_invite = @isInvite, @parm_logged = null,
          @parm_filePost = null, @parm_disabled = @isDisabled, @parm_siopID = @siopID
        set @updated = 1
      end
    else 
      begin
        exec [procInsertNode_p] @parm_nodeID = @nodeID, @parm_parentID = @parentDbId, @parm_nodeType = 0,
          @parm_nodeName = @name, @parm_nodeDesc = @desc, @parm_behavior = @behavior,
          @parm_siopID = @siopID,
          @parm_nodeAddedBy = @addedByDbId, @parm_nodeAddedOn = @addedOn, @parm_nodeUpdatedBy = @updatedByDbId,
          @parm_nodeUpdatedOn = @updatedOn, @parm_visibility = @visibility,
          @parm_invite = @isInvite, @parm_logged = null, @parm_filePost = null,
          @parm_disabled = @isDisabled, @parm_dbId = @nodeDbId out
        set @updated = 0
      end
    declare @forbidMembers bit
    declare @forbidPresenters bit
	-- open rooms cannot have members (some prerelease W15 builds allowed that)
	if @visibility = 6
	  set @forbidMembers = 1
    else
	  set @forbidMembers = 0
	if @behavior <> 5
	  set @forbidPresenters = 1
    else
	  set @forbidPresenters = 0
    declare @innerXml xml
    select
      @innerXml = room.query('.')
    from
      @xml.nodes('ChatRoom/Roles') chat (room)
    exec Imp_Roles_p @nodeDbId, @innerXml, @forbidMembers, @forbidPresenters
  end try
  begin catch
		exec RethrowError
    return -1
  end catch
go
create procedure [dbo].Imp_Chats
  (
		@channelId uniqueidentifier
	 ,@xml xml
  )
as
	declare @nodeDbId int
	select @nodeDbId = nodeID from tblNode where nodeGuid = @channelId
	
    if (@xml.exist('Chats/Chat') = 1) 
      begin
        insert into
          [tblChat]
          (
           [channelId]
          ,[chatId]
          ,[chatDate]
          ,[userId]
          ,[isAlert]
          ,[content]
          ,[rtf]
          )
          select
            @nodeDbId
           ,chat.value('@id', 'bigint')
           ,[dbo].fnDateToTicks(chat.value('@date', 'datetime'))
           ,p.prinID
           ,isnull(chat.value('@isAlert', 'bit'), 0)
           ,chat.value('data(Content)[1]', 'nvarchar(4000)')
           ,chat.value('data(Rtf)[1]', 'varchar(max)')
          from
            @xml.nodes('Chats/Chat') cat (chat)
            left outer join tblPrincipal p on chat.value('@userId', 'uniqueidentifier') = p.prinGuid
          order by
            chat.value('@id', 'bigint')
        update
          [tblLastChatId]
        set
          [lastChatID] = (
                          select max ([chatId]) from [tblChat] where [channelId] = @nodeDbId
                         )
        where
          [nodeID] = @nodeDbId
      end
go
create procedure [dbo].Imp_Siops
  (
	@xml xml
   ,@insertOnly bit = 1
   ,@updated bit output	
  )
as
        declare 
           @siopID uniqueidentifier
          ,@siopEntries int 
          ,@siopName nvarchar(255)
          ,@siopUrl nvarchar(255)          
        select
           @siopID = siop.value('@id', 'uniqueidentifier')
          ,@siopName = siop.value('@name', 'nvarchar(255)')
          ,@siopUrl = siop.value('@url', 'nvarchar(255)')
          from
            @xml.nodes('Siop') s (siop)
        select 
          @siopEntries = count(*)
        from
          [tblSiopWhiteList] 
        where
          [siopID] = @siopID
        if (@siopEntries = 0)
          begin
            insert into
              [tblSiopWhiteList]
              (
                [siopID]
               ,[siopName]
               ,[siopUrl]
              )
            values
              (
                @siopID
               ,@siopName
               ,@siopUrl
              )
            set @updated = 0
          end
        else
          begin
            if @insertOnly = 1
              begin
                declare @siopIDString nvarchar(36)
                set @siopIDString = cast(@siopID as nvarchar(36))
                raiserror (51100, 16, 1, 'Siop', @siopIDString)
                return -1
              end
            update 
              [tblSiopWhiteList]
            set
               [siopName] = @siopName
              ,[siopUrl] = @siopUrl
            where
               [siopID] = @siopID 
            set @updated = 1
          end           
GO
create procedure [dbo].Imp_Pref
  (
   @xml xml
  ,@insertOnly bit = 1
  ,@updated bit output
  )
as 
  declare
    @userId uniqueidentifier
   ,@userUri nvarchar(256)
  select
    @userId = prefs.value('@userId', 'uniqueidentifier')
  from
    @xml.nodes('User') u (prefs)
		
	--assert user does not exist or update is allowed
  select
    @userUri = prinUri
  from
    tblPrincipal
  where
    prinGuid = @userId
  if @userUri is null 
    begin
      declare @idString nvarchar(36)
      set @idString = cast(@userId as nvarchar(36))
      raiserror (50200, 16, 1, @idString)
      return -1
    end
	set @updated = 0
	if exists(select * from Exp_PrefView where userUri = @userUri collate Latin1_General_CI_AS)
	begin
		if @insertOnly = 1
			begin
				raiserror (51103, 16, 1, 'Preferences', @userUri)
				return -1
			end
		else
			begin
				set @updated = 1
			end
	end
  declare prefCursor cursor
    for select
          @userUri + '|' + prefs.value('@label', 'nvarchar(256)')
         ,prefs.value('@seqId', 'int')
         ,prefs.value('data(Content)[1]', 'nvarchar(max)')
        from
          @xml.nodes('User/Preferences/Preference') u (prefs)
  open prefCursor
  declare
    @label nvarchar(256)
   ,@seqId int
   ,@content nvarchar(max)
  fetch next from prefCursor into @label, @seqId, @content
  set xact_abort on
  begin transaction
  if @updated = 1
		delete from [tblPreference] where [prefLabel] collate Latin1_General_CI_AS like @userUri + '|%'
  while(@@fetch_status <> -1)
    begin
      if (@@fetch_status <> -2)
				begin
					exec procSetPreference_p @label = @label, @seqId = @seqId, @content = @content, @updater = 1
				end
      fetch next from prefCursor into @label, @seqId, @content
    end
  commit transaction
  close prefCursor
  deallocate prefCursor
go
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
declare @name nvarchar(255), @command nvarchar(300)
while exists( select name from sysobjects where xtype = 'TR' )
begin
    declare trcursor cursor for
    select name from sysobjects where xtype = 'TR' --triggers
    open trcursor
    fetch next from trcursor into @name
    while (@@fetch_status = 0)
      begin
        set @command = 'drop trigger ' + @name
        exec sp_executesql @command
        fetch next from trcursor into @name
      end
    close trcursor
    deallocate trcursor
end
GO
CREATE TRIGGER
dbo.trgNodeInsert ON  dbo.tblNode FOR INSERT AS
BEGIN
    SET NOCOUNT ON       
    INSERT INTO tblLastChatId (nodeID, lastChatID)
        select nodeID, 0
        from inserted
        where inserted.nodeType = 0
END
GO
CREATE TRIGGER
dbo.trgNodeUpdate ON  dbo.tblNode FOR UPDATE AS
BEGIN
    SET NOCOUNT ON
    IF UPDATE(disabled)
    BEGIN
        SET NOCOUNT ON
        DECLARE @disabledNodes TABLE(nodeID int)
        insert into 
            @disabledNodes
        select 
            i.nodeID 
        from
            inserted i
            inner join deleted d on i.nodeID = d.nodeID and i.disabled <> d.disabled
        where
            i.disabled = 1
        if exists (select * from @disabledNodes)
        BEGIN
            delete from tblPrincipalInvites
            where 
                nodeID in (select nodeID from @disabledNodes)
        END
    END
END
GO
